import { Data, Entities } from "./Trello";
import { KintoneRestAPIClient } from "@kintone/rest-api-client";
export declare const registerRecordIdToTrello: (id: string, baseUrl: string, cardAppId: string, trelloApiKey: string, trelloApiToken: string, eptreId: string, prefixRecordId: string) => Promise<{
    url: any;
    status: any;
    statusText: any;
    text: any;
}>;
export declare const addRecordIdToCardNameOfTrello: (cardId: string, trelloApiKey: string, trelloApiToken: string, nowCardName: string, eptreId: string, prefixRecordID: string) => Promise<{
    newName: string;
    url: any;
    status: any;
    statusText: any;
    text: any;
} | undefined>;
export declare const ApiExecutor: {
    createCard: (client: KintoneRestAPIClient, appId: string, data: Data) => Promise<{
        app: string;
        record: {
            [key: string]: {
                value: any;
            };
        };
    }>;
    updateCard: (client: KintoneRestAPIClient, appId: string, data: Data, recordId: string) => Promise<{
        [key: string]: {
            value: any;
        };
    }>;
    createLabel: (client: KintoneRestAPIClient, appId: string, data: Data) => Promise<{
        app: string;
        record: {
            [x: string]: {
                value: string;
            };
        };
    }>;
    updateLabel: (client: KintoneRestAPIClient, appId: string, data: Data, sameLabelId: string) => Promise<{
        app: string;
        id: string;
        record: {
            [x: string]: {
                value: string;
            };
        };
    }>;
    createList: (client: KintoneRestAPIClient, appId: string, data: Data) => Promise<{
        app: string;
        record: {
            NAME: {
                value: string | undefined;
            };
            ID: {
                value: string | undefined;
            };
        };
    }>;
    updateList: (client: KintoneRestAPIClient, appId: string, data: Data, recordId: string) => Promise<{
        [key: string]: {
            value: any;
        };
    }>;
    addMember: (client: KintoneRestAPIClient, appId: string, data: Data, kintoneUserId: string) => Promise<{
        app: string;
        record: {
            [x: string]: {
                value: string;
            } | {
                value: {
                    code: string;
                }[];
            };
        };
    }>;
    addLabelToCard: (client: KintoneRestAPIClient, appId: string, data: Data, recordId: string, tableIds: {
        id: string;
        value: {
            [key: string]: any;
        };
    }[]) => Promise<{
        app: string;
        id: string;
        record: {
            [x: string]: {
                value: any[];
            };
        };
    }>;
    removeLabelFromCard: (client: KintoneRestAPIClient, appId: string, data: Data, recordId: string, tableIds: {
        id: string;
        value: {
            [key: string]: any;
        };
    }[]) => Promise<{
        app: string;
        id: string;
        record: {
            [x: string]: {
                value: {
                    id: string;
                }[];
            };
        };
    }>;
    addMemberToCard: (client: KintoneRestAPIClient, appId: string, cardID: string, kintoneUserCode: string, kintoneUserCodesOfSetted: string[]) => Promise<{
        app: string;
        id: string;
        record: {
            [x: string]: {
                value: any[];
            };
        };
    }>;
    getRecordIdFromCard: (client: KintoneRestAPIClient, appId: string, data: Data) => Promise<string | undefined>;
    getKintoneUserCode: (client: KintoneRestAPIClient, appId: string, data: Data) => Promise<string | undefined>;
    getKintoneUserCodesOfSetted: (client: KintoneRestAPIClient, appId: string, data: Data) => Promise<string[]>;
    getRecordIdAndLabelIdsFromCard: (client: KintoneRestAPIClient, appId: string, data: Data) => Promise<{
        recordId: string;
        tableIds: {
            id: string;
            value: {
                [key: string]: any;
            };
        }[];
    } | undefined>;
    getRecordIdFromLabelOfSame: (client: KintoneRestAPIClient, appId: string, data: Data) => Promise<string | undefined>;
    removeMemberFromCard: (client: KintoneRestAPIClient, appId: string, cardID: string, kintoneUserCode: string, kintoneUserCodesOfSetted: string[]) => Promise<{
        app: string;
        id: string;
        record: {
            [x: string]: {
                value: any[];
            };
        };
    }>;
    getRecordIdFromList: (client: KintoneRestAPIClient, appId: string, data: Data) => Promise<string | undefined>;
    addTimeOfDoneToRecord: (client: KintoneRestAPIClient, appId: string, recordId: string, doneTime: Date) => Promise<{
        app: string;
        id: string;
        record: {
            [x: string]: {
                value: Date;
            };
        };
    }>;
    commentCard: (client: KintoneRestAPIClient, appId: string, entities: Entities, cardID: string) => Promise<{
        app: string;
        record: string;
        comment: {
            text: string;
        };
    }>;
    registerRecordIdToTrello: (id: string, baseUrl: string, cardAppId: string, trelloApiKey: string, trelloApiToken: string, eptreId: string, prefixRecordId: string) => Promise<{
        url: any;
        status: any;
        statusText: any;
        text: any;
    }>;
    addRecordIdToCardNameOfTrello: (cardId: string, trelloApiKey: string, trelloApiToken: string, nowCardName: string, eptreId: string, prefixRecordID: string) => Promise<{
        newName: string;
        url: any;
        status: any;
        statusText: any;
        text: any;
    } | undefined>;
    attachmentToCard: (client: KintoneRestAPIClient, appId: string, data: Data, recordId: string, attachmentsTableIds: Array<{
        id: string;
    }>) => Promise<{
        app: string;
        id: string;
        record: {
            [x: string]: {
                value: any[];
            };
        };
    }>;
    getRecordIdAndAttachmentIdsFromCard: (client: KintoneRestAPIClient, appId: string, data: Data) => Promise<{
        recordId: string;
        attachmentsTableIds: Array<{
            id: string;
        }>;
    } | undefined>;
};
