import { Action, Certificate } from "./Trello";
import { Apps } from "./Kintone";
import { KintoneRestAPIClient } from "@kintone/rest-api-client";
import { SettingGuardian } from "./Setting";
export declare class Worker {
    trelloAction: Action;
    private readonly kintoneClientCreator;
    private readonly apps;
    private readonly trelloCert;
    setting?: SettingGuardian;
    constructor(apps: Apps, trelloCert: Certificate);
    action(): Promise<string | {
        app: string;
        record: {
            [key: string]: {
                value: any;
            };
        };
    } | {
        [key: string]: {
            value: any;
        };
    } | {
        app: string;
        record: string;
        comment: {
            text: string;
        };
    }>;
    postAction(): Promise<(string | {
        app: string;
        id: string;
        record: {
            [x: string]: {
                value: Date;
            };
        };
    } | {
        url: any;
        status: any;
        statusText: any;
        text: any;
    } | Promise<{
        url: any;
        status: any;
        statusText: any;
        text: any;
    }> | undefined)[]>;
    registerRecordIdToTrello(): Promise<{
        url: any;
        status: any;
        statusText: any;
        text: any;
    }>;
    addRecordIdToCardNameOfTrello(): Promise<{
        newName: string;
        url: any;
        status: any;
        statusText: any;
        text: any;
    } | undefined>;
    getCardRecordIdIfNotExistsCreateCard(client: KintoneRestAPIClient): Promise<string>;
    getKintoneUserCodeIfNotExistsAddMember(client: KintoneRestAPIClient): Promise<string>;
    createCard(): Promise<{
        app: string;
        record: {
            [key: string]: {
                value: any;
            };
        };
    }>;
    updateCard(): Promise<{
        [key: string]: {
            value: any;
        };
    }>;
    copyCard(): Promise<{
        app: string;
        record: {
            [key: string]: {
                value: any;
            };
        };
    }>;
    createList(): Promise<{
        app: string;
        record: {
            NAME: {
                value: string | undefined;
            };
            ID: {
                value: string | undefined;
            };
        };
    }>;
    updateList(): Promise<{
        [key: string]: {
            value: any;
        };
    }>;
    createLabel(): Promise<{
        app: string;
        record: {
            [x: string]: {
                value: string;
            };
        };
    }>;
    updateLabel(): Promise<{
        app: string;
        record: {
            [x: string]: {
                value: string;
            };
        };
    }>;
    getRecordIdAndLabelIdsFromCard(): Promise<{
        recordId: string;
        tableIds: {
            id: string;
            value: {
                [key: string]: any;
            };
        }[];
    }>;
    addLabelToCard(): Promise<{
        app: string;
        id: string;
        record: {
            [x: string]: {
                value: any[];
            };
        };
    }>;
    removeLabelFromCard(): Promise<{
        app: string;
        id: string;
        record: {
            [x: string]: {
                value: {
                    id: string;
                }[];
            };
        };
    }>;
    addMemberToCard(): Promise<{
        app: string;
        id: string;
        record: {
            [x: string]: {
                value: any[];
            };
        };
    }>;
    removeMemberFromCard(): Promise<{
        app: string;
        id: string;
        record: {
            [x: string]: {
                value: any[];
            };
        };
    }>;
    commentCard(): Promise<{
        app: string;
        record: string;
        comment: {
            text: string;
        };
    }>;
    addTimeOfDoneToRecord(): Promise<{
        app: string;
        id: string;
        record: {
            [x: string]: {
                value: Date;
            };
        };
    } | "Skip addTimeOfDoneToRecord">;
    getRecordIdAndAttachmentIdsFromCard(): Promise<{
        recordId: string;
        attachmentsTableIds: {
            id: string;
        }[];
    }>;
    attachmentToCard(): Promise<string | {
        app: string;
        id: string;
        record: {
            [x: string]: {
                value: any[];
            };
        };
    }>;
}
