var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { ActionType } from "./Trello";
import { KintoneClientCreator } from "./KintoneClientCreator";
import { ApiExecutor } from "./ApiExecutor";
var Worker = /** @class */ (function () {
    function Worker(apps, trelloCert) {
        this.kintoneClientCreator = new KintoneClientCreator(apps.baseUrl);
        this.apps = apps;
        this.trelloCert = trelloCert;
        this.trelloAction = {};
    }
    Worker.prototype.action = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (this.trelloAction.type) {
                    case ActionType.CREATE_CARD: {
                        return [2 /*return*/, this.createCard()];
                    }
                    case ActionType.UPDATE_CARD: {
                        return [2 /*return*/, this.updateCard()];
                    }
                    case ActionType.COPY_CARD: {
                        return [2 /*return*/, this.copyCard()];
                    }
                    case ActionType.CREATE_LIST: {
                        return [2 /*return*/, this.createList()];
                    }
                    case ActionType.UPDATE_LIST: {
                        return [2 /*return*/, this.updateList()];
                    }
                    case ActionType.CREATE_LABEL: {
                        return [2 /*return*/, this.createLabel()];
                    }
                    case ActionType.UPDATE_LABEL: {
                        return [2 /*return*/, this.updateLabel()];
                    }
                    case ActionType.ADD_LABEL_TO_CARD: {
                        return [2 /*return*/, this.addLabelToCard()];
                    }
                    case ActionType.REMOVE_LABEL_FROM_CARD: {
                        return [2 /*return*/, this.removeLabelFromCard()];
                    }
                    case ActionType.ADD_MEMBER_TO_CARD: {
                        return [2 /*return*/, this.addMemberToCard()];
                    }
                    case ActionType.REMOVE_MEMBER_FROM_CARD: {
                        return [2 /*return*/, this.removeMemberFromCard()];
                    }
                    case ActionType.COMMENT_CARD: {
                        return [2 /*return*/, this.commentCard()];
                    }
                    case ActionType.ADD_ATTACHMENT_TO_CARD: {
                        console.log("Add attachment to card");
                        return [2 /*return*/, this.attachmentToCard()];
                    }
                }
                return [2 /*return*/, Promise.resolve({ app: "", record: {} })];
            });
        });
    };
    Worker.prototype.postAction = function () {
        return __awaiter(this, void 0, void 0, function () {
            var result, _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u, _v, _w, _x, _y;
            return __generator(this, function (_z) {
                switch (_z.label) {
                    case 0:
                        result = [];
                        _a = this.trelloAction.type;
                        switch (_a) {
                            case ActionType.CREATE_CARD: return [3 /*break*/, 1];
                            case ActionType.COPY_CARD: return [3 /*break*/, 4];
                            case ActionType.UPDATE_CARD: return [3 /*break*/, 6];
                            case ActionType.ADD_LABEL_TO_CARD: return [3 /*break*/, 9];
                            case ActionType.REMOVE_LABEL_FROM_CARD: return [3 /*break*/, 11];
                            case ActionType.ADD_MEMBER_TO_CARD: return [3 /*break*/, 13];
                            case ActionType.REMOVE_MEMBER_FROM_CARD: return [3 /*break*/, 15];
                            case ActionType.COMMENT_CARD: return [3 /*break*/, 17];
                            case ActionType.ADD_ATTACHMENT_TO_CARD: return [3 /*break*/, 19];
                        }
                        return [3 /*break*/, 21];
                    case 1:
                        _c = (_b = result).push;
                        return [4 /*yield*/, this.registerRecordIdToTrello()];
                    case 2:
                        _c.apply(_b, [_z.sent()]);
                        _e = (_d = result).push;
                        return [4 /*yield*/, this.addRecordIdToCardNameOfTrello()];
                    case 3:
                        _e.apply(_d, [_z.sent()]);
                        return [3 /*break*/, 21];
                    case 4:
                        result.push(this.registerRecordIdToTrello());
                        _g = (_f = result).push;
                        return [4 /*yield*/, this.addRecordIdToCardNameOfTrello()];
                    case 5:
                        _g.apply(_f, [_z.sent()]);
                        return [3 /*break*/, 21];
                    case 6:
                        _j = (_h = result).push;
                        return [4 /*yield*/, this.addRecordIdToCardNameOfTrello()];
                    case 7:
                        _j.apply(_h, [_z.sent()]);
                        _l = (_k = result).push;
                        return [4 /*yield*/, this.addTimeOfDoneToRecord()];
                    case 8:
                        _l.apply(_k, [_z.sent()]);
                        return [3 /*break*/, 21];
                    case 9:
                        _o = (_m = result).push;
                        return [4 /*yield*/, this.addRecordIdToCardNameOfTrello()];
                    case 10:
                        _o.apply(_m, [_z.sent()]);
                        return [3 /*break*/, 21];
                    case 11:
                        _q = (_p = result).push;
                        return [4 /*yield*/, this.addRecordIdToCardNameOfTrello()];
                    case 12:
                        _q.apply(_p, [_z.sent()]);
                        return [3 /*break*/, 21];
                    case 13:
                        _s = (_r = result).push;
                        return [4 /*yield*/, this.addRecordIdToCardNameOfTrello()];
                    case 14:
                        _s.apply(_r, [_z.sent()]);
                        return [3 /*break*/, 21];
                    case 15:
                        _u = (_t = result).push;
                        return [4 /*yield*/, this.addRecordIdToCardNameOfTrello()];
                    case 16:
                        _u.apply(_t, [_z.sent()]);
                        return [3 /*break*/, 21];
                    case 17:
                        _w = (_v = result).push;
                        return [4 /*yield*/, this.addRecordIdToCardNameOfTrello()];
                    case 18:
                        _w.apply(_v, [_z.sent()]);
                        return [3 /*break*/, 21];
                    case 19:
                        _y = (_x = result).push;
                        return [4 /*yield*/, this.addRecordIdToCardNameOfTrello()];
                    case 20:
                        _y.apply(_x, [_z.sent()]);
                        _z.label = 21;
                    case 21: return [2 /*return*/, Promise.resolve(result)];
                }
            });
        });
    };
    Worker.prototype.registerRecordIdToTrello = function () {
        return __awaiter(this, void 0, void 0, function () {
            var client, cardRecordId;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.kintoneClientCreator.createKintoneClient([
                            this.apps.cards.token,
                        ])];
                    case 1:
                        client = _a.sent();
                        return [4 /*yield*/, this.getCardRecordIdIfNotExistsCreateCard(client)];
                    case 2:
                        cardRecordId = _a.sent();
                        if (cardRecordId === undefined) {
                            throw new Error("Not exists Card");
                        }
                        if (this.setting === undefined) {
                            throw new Error("Need setting");
                        }
                        return [2 /*return*/, ApiExecutor.registerRecordIdToTrello(this.trelloAction.data.card.id, this.apps.baseUrl, this.apps.cards.id, this.trelloCert.apiKey, this.trelloCert.apiToken, cardRecordId, this.setting.getPrefixRecordId())];
                }
            });
        });
    };
    Worker.prototype.addRecordIdToCardNameOfTrello = function () {
        return __awaiter(this, void 0, void 0, function () {
            var client, cardRecordId;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.kintoneClientCreator.createKintoneClient([
                            this.apps.cards.token,
                        ])];
                    case 1:
                        client = _a.sent();
                        return [4 /*yield*/, this.getCardRecordIdIfNotExistsCreateCard(client)];
                    case 2:
                        cardRecordId = _a.sent();
                        if (cardRecordId === undefined) {
                            throw new Error("Not exists Card");
                        }
                        if (this.setting === undefined) {
                            throw new Error("Need setting");
                        }
                        return [2 /*return*/, ApiExecutor.addRecordIdToCardNameOfTrello(this.trelloAction.data.card.id, this.trelloCert.apiKey, this.trelloCert.apiToken, this.trelloAction.data.card.name, cardRecordId, this.setting.getPrefixRecordId())];
                }
            });
        });
    };
    Worker.prototype.getCardRecordIdIfNotExistsCreateCard = function (client) {
        return __awaiter(this, void 0, void 0, function () {
            var cardRecordId;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, ApiExecutor.getRecordIdFromCard(client, this.apps.cards.id, this.trelloAction.data)];
                    case 1:
                        cardRecordId = _a.sent();
                        if (!(cardRecordId === undefined)) return [3 /*break*/, 4];
                        return [4 /*yield*/, ApiExecutor.createCard(client, this.apps.cards.id, this.trelloAction.data)];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, ApiExecutor.getRecordIdFromCard(client, this.apps.cards.id, this.trelloAction.data)];
                    case 3:
                        cardRecordId = _a.sent();
                        _a.label = 4;
                    case 4: return [2 /*return*/, cardRecordId];
                }
            });
        });
    };
    Worker.prototype.getKintoneUserCodeIfNotExistsAddMember = function (client) {
        return __awaiter(this, void 0, void 0, function () {
            var kintoneUserCode;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, ApiExecutor.getKintoneUserCode(client, this.apps.members.id, this.trelloAction.data)];
                    case 1:
                        kintoneUserCode = _a.sent();
                        if (!(kintoneUserCode === undefined)) return [3 /*break*/, 3];
                        return [4 /*yield*/, ApiExecutor.addMember(client, this.apps.members.id, this.trelloAction.data, this.apps.defaultKintoneUserCode)];
                    case 2:
                        _a.sent();
                        return [2 /*return*/, this.apps.defaultKintoneUserCode];
                    case 3: return [2 /*return*/, kintoneUserCode];
                }
            });
        });
    };
    Worker.prototype.createCard = function () {
        return __awaiter(this, void 0, void 0, function () {
            var client;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.kintoneClientCreator.createKintoneClient([
                            this.apps.cards.token,
                            this.apps.lists.token,
                        ])];
                    case 1:
                        client = _a.sent();
                        return [2 /*return*/, ApiExecutor.createCard(client, this.apps.cards.id, this.trelloAction.data)];
                }
            });
        });
    };
    Worker.prototype.updateCard = function () {
        return __awaiter(this, void 0, void 0, function () {
            var client, listRecordId, cardRecordId;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.kintoneClientCreator.createKintoneClient([
                            this.apps.cards.token,
                            this.apps.lists.token,
                        ])];
                    case 1:
                        client = _a.sent();
                        if (!(Object.prototype.hasOwnProperty.call("card", "idList") ||
                            Object.prototype.hasOwnProperty.call("data", "list"))) return [3 /*break*/, 4];
                        return [4 /*yield*/, ApiExecutor.getRecordIdFromList(client, this.apps.lists.id, this.trelloAction.data)];
                    case 2:
                        listRecordId = _a.sent();
                        console.log(listRecordId);
                        if (!(listRecordId === undefined)) return [3 /*break*/, 4];
                        return [4 /*yield*/, ApiExecutor.createList(client, this.apps.lists.id, this.trelloAction.data)];
                    case 3:
                        _a.sent();
                        _a.label = 4;
                    case 4: return [4 /*yield*/, this.getCardRecordIdIfNotExistsCreateCard(client)];
                    case 5:
                        cardRecordId = _a.sent();
                        return [2 /*return*/, ApiExecutor.updateCard(client, this.apps.cards.id, this.trelloAction.data, cardRecordId)];
                }
            });
        });
    };
    Worker.prototype.copyCard = function () {
        return __awaiter(this, void 0, void 0, function () {
            var client;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.kintoneClientCreator.createKintoneClient([
                            this.apps.cards.token,
                            this.apps.lists.token,
                        ])];
                    case 1:
                        client = _a.sent();
                        return [2 /*return*/, ApiExecutor.createCard(client, this.apps.cards.id, this.trelloAction.data)];
                }
            });
        });
    };
    Worker.prototype.createList = function () {
        return __awaiter(this, void 0, void 0, function () {
            var client;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.kintoneClientCreator.createKintoneClient(this.apps.lists.token)];
                    case 1:
                        client = _a.sent();
                        return [2 /*return*/, ApiExecutor.createList(client, this.apps.lists.id, this.trelloAction.data)];
                }
            });
        });
    };
    Worker.prototype.updateList = function () {
        return __awaiter(this, void 0, void 0, function () {
            var client, listRecordId;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.kintoneClientCreator.createKintoneClient(this.apps.lists.token)];
                    case 1:
                        client = _a.sent();
                        return [4 /*yield*/, ApiExecutor.getRecordIdFromList(client, this.apps.lists.id, this.trelloAction.data)];
                    case 2:
                        listRecordId = _a.sent();
                        if (!(listRecordId === undefined)) return [3 /*break*/, 5];
                        return [4 /*yield*/, ApiExecutor.createList(client, this.apps.lists.id, this.trelloAction.data)];
                    case 3:
                        _a.sent();
                        return [4 /*yield*/, ApiExecutor.getRecordIdFromList(client, this.apps.lists.id, this.trelloAction.data)];
                    case 4:
                        listRecordId = _a.sent();
                        _a.label = 5;
                    case 5: return [2 /*return*/, ApiExecutor.updateList(client, this.apps.lists.id, this.trelloAction.data, listRecordId)];
                }
            });
        });
    };
    Worker.prototype.createLabel = function () {
        return __awaiter(this, void 0, void 0, function () {
            var client;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.kintoneClientCreator.createKintoneClient(this.apps.labels.token)];
                    case 1:
                        client = _a.sent();
                        return [2 /*return*/, ApiExecutor.createLabel(client, this.apps.labels.id, this.trelloAction.data)];
                }
            });
        });
    };
    Worker.prototype.updateLabel = function () {
        return __awaiter(this, void 0, void 0, function () {
            var client, sameLabelId;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.kintoneClientCreator.createKintoneClient(this.apps.labels.token)];
                    case 1:
                        client = _a.sent();
                        return [4 /*yield*/, ApiExecutor.getRecordIdFromLabelOfSame(client, this.apps.labels.id, this.trelloAction.data)];
                    case 2:
                        sameLabelId = _a.sent();
                        if (sameLabelId === undefined) {
                            return [2 /*return*/, ApiExecutor.createLabel(client, this.apps.labels.id, this.trelloAction.data)];
                        }
                        return [2 /*return*/, ApiExecutor.updateLabel(client, this.apps.labels.id, this.trelloAction.data, sameLabelId)];
                }
            });
        });
    };
    Worker.prototype.getRecordIdAndLabelIdsFromCard = function () {
        return __awaiter(this, void 0, void 0, function () {
            var client, cardInfo, labelRecordId;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.kintoneClientCreator.createKintoneClient([
                            this.apps.cards.token,
                            this.apps.labels.token,
                        ])];
                    case 1:
                        client = _a.sent();
                        return [4 /*yield*/, ApiExecutor.getRecordIdAndLabelIdsFromCard(client, this.apps.cards.id, this.trelloAction.data)];
                    case 2:
                        cardInfo = _a.sent();
                        if (cardInfo === undefined) {
                            throw new Error("Card is no such exists");
                        }
                        return [4 /*yield*/, ApiExecutor.getRecordIdFromLabelOfSame(client, this.apps.labels.id, this.trelloAction.data)];
                    case 3:
                        labelRecordId = _a.sent();
                        if (!(labelRecordId === undefined)) return [3 /*break*/, 5];
                        return [4 /*yield*/, ApiExecutor.createLabel(client, this.apps.labels.id, this.trelloAction.data)];
                    case 4:
                        _a.sent();
                        _a.label = 5;
                    case 5: return [2 /*return*/, cardInfo];
                }
            });
        });
    };
    Worker.prototype.addLabelToCard = function () {
        return __awaiter(this, void 0, void 0, function () {
            var client, cardInfo;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.kintoneClientCreator.createKintoneClient([
                            this.apps.cards.token,
                            this.apps.labels.token,
                        ])];
                    case 1:
                        client = _a.sent();
                        return [4 /*yield*/, this.getRecordIdAndLabelIdsFromCard()];
                    case 2:
                        cardInfo = _a.sent();
                        cardInfo.tableIds.forEach(function (record) {
                            if (record.value.LABEL_ID.value === _this.trelloAction.data.label.id) {
                                throw new Error("Label " + _this.trelloAction.data.label.name + "(" + _this.trelloAction.data.label.id + ") is already exists");
                            }
                        });
                        return [2 /*return*/, ApiExecutor.addLabelToCard(client, this.apps.cards.id, this.trelloAction.data, cardInfo.recordId, cardInfo.tableIds)];
                }
            });
        });
    };
    Worker.prototype.removeLabelFromCard = function () {
        return __awaiter(this, void 0, void 0, function () {
            var client, cardInfo;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.kintoneClientCreator.createKintoneClient([
                            this.apps.cards.token,
                            this.apps.labels.token,
                        ])];
                    case 1:
                        client = _a.sent();
                        return [4 /*yield*/, this.getRecordIdAndLabelIdsFromCard()];
                    case 2:
                        cardInfo = _a.sent();
                        return [2 /*return*/, ApiExecutor.removeLabelFromCard(client, this.apps.cards.id, this.trelloAction.data, cardInfo.recordId, cardInfo.tableIds)];
                }
            });
        });
    };
    Worker.prototype.addMemberToCard = function () {
        return __awaiter(this, void 0, void 0, function () {
            var client, recordId, kintoneUserCode, kintoneUserCodesOfSetted;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.kintoneClientCreator.createKintoneClient([
                            this.apps.members.token,
                            this.apps.cards.token,
                        ])];
                    case 1:
                        client = _a.sent();
                        return [4 /*yield*/, this.getCardRecordIdIfNotExistsCreateCard(client)];
                    case 2:
                        recordId = _a.sent();
                        return [4 /*yield*/, this.getKintoneUserCodeIfNotExistsAddMember(client)];
                    case 3:
                        kintoneUserCode = _a.sent();
                        return [4 /*yield*/, ApiExecutor.getKintoneUserCodesOfSetted(client, this.apps.cards.id, this.trelloAction.data)];
                    case 4:
                        kintoneUserCodesOfSetted = _a.sent();
                        return [2 /*return*/, ApiExecutor.addMemberToCard(client, this.apps.cards.id, recordId, kintoneUserCode, kintoneUserCodesOfSetted)];
                }
            });
        });
    };
    Worker.prototype.removeMemberFromCard = function () {
        return __awaiter(this, void 0, void 0, function () {
            var client, recordId, kintoneUserCode, kintoneUserCodesOfSetted;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.kintoneClientCreator.createKintoneClient([
                            this.apps.members.token,
                            this.apps.cards.token,
                        ])];
                    case 1:
                        client = _a.sent();
                        return [4 /*yield*/, this.getCardRecordIdIfNotExistsCreateCard(client)];
                    case 2:
                        recordId = _a.sent();
                        return [4 /*yield*/, this.getKintoneUserCodeIfNotExistsAddMember(client)];
                    case 3:
                        kintoneUserCode = _a.sent();
                        return [4 /*yield*/, ApiExecutor.getKintoneUserCodesOfSetted(client, this.apps.cards.id, this.trelloAction.data)];
                    case 4:
                        kintoneUserCodesOfSetted = _a.sent();
                        return [2 /*return*/, ApiExecutor.removeMemberFromCard(client, this.apps.cards.id, recordId, kintoneUserCode, kintoneUserCodesOfSetted)];
                }
            });
        });
    };
    Worker.prototype.commentCard = function () {
        return __awaiter(this, void 0, void 0, function () {
            var client, recordId;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.kintoneClientCreator.createKintoneClient([
                            this.apps.cards.token,
                        ])];
                    case 1:
                        client = _a.sent();
                        return [4 /*yield*/, this.getCardRecordIdIfNotExistsCreateCard(client)];
                    case 2:
                        recordId = _a.sent();
                        return [2 /*return*/, ApiExecutor.commentCard(client, this.apps.cards.id, this.trelloAction.display.entities, recordId)];
                }
            });
        });
    };
    Worker.prototype.addTimeOfDoneToRecord = function () {
        return __awaiter(this, void 0, void 0, function () {
            var client, recordId, doneTime;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (this.setting === undefined ||
                            this.trelloAction.data.listAfter === undefined ||
                            !this.setting.isAddDoneTime(this.trelloAction.data.listAfter.name))
                            // 設定がない or リストの移動でない or Doneへの移動でないなら何もせずreturn
                            return [2 /*return*/, "Skip addTimeOfDoneToRecord"];
                        return [4 /*yield*/, this.kintoneClientCreator.createKintoneClient([
                                this.apps.cards.token,
                            ])];
                    case 1:
                        client = _a.sent();
                        return [4 /*yield*/, this.getCardRecordIdIfNotExistsCreateCard(client)];
                    case 2:
                        recordId = _a.sent();
                        doneTime = this.trelloAction.date;
                        return [2 /*return*/, ApiExecutor.addTimeOfDoneToRecord(client, this.apps.cards.id, recordId, doneTime)];
                }
            });
        });
    };
    Worker.prototype.getRecordIdAndAttachmentIdsFromCard = function () {
        return __awaiter(this, void 0, void 0, function () {
            var client, cardInfo;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.kintoneClientCreator.createKintoneClient([
                            this.apps.cards.token,
                        ])];
                    case 1:
                        client = _a.sent();
                        return [4 /*yield*/, ApiExecutor.getRecordIdAndAttachmentIdsFromCard(client, this.apps.cards.id, this.trelloAction.data)];
                    case 2:
                        cardInfo = _a.sent();
                        if (cardInfo === undefined) {
                            throw new Error("Card is no such exists");
                        }
                        return [2 /*return*/, cardInfo];
                }
            });
        });
    };
    Worker.prototype.attachmentToCard = function () {
        return __awaiter(this, void 0, void 0, function () {
            var client, attachmentName, checkDuplicate, find, cardInfo;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.kintoneClientCreator.createKintoneClient([
                            this.apps.cards.token,
                        ])];
                    case 1:
                        client = _a.sent();
                        attachmentName = this.trelloAction.data.attachment.name;
                        if (this.setting !== undefined) {
                            checkDuplicate = new RegExp(this.setting.getPrefixRecordId() + "-\\d+");
                            find = attachmentName.match(checkDuplicate);
                            if (find !== null)
                                return [2 /*return*/, "Skip attachmentToCard because " + attachmentName];
                        }
                        return [4 /*yield*/, this.getRecordIdAndAttachmentIdsFromCard()];
                    case 2:
                        cardInfo = _a.sent();
                        return [2 /*return*/, ApiExecutor.attachmentToCard(client, this.apps.cards.id, this.trelloAction.data, cardInfo.recordId, cardInfo.attachmentsTableIds)];
                }
            });
        });
    };
    return Worker;
}());
export { Worker };
