/* eslint-disable no-loop-func */
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
import { ApiExecutor } from "../ApiExecutor";
import { KintoneRestAPIClient } from "@kintone/rest-api-client";
import { CardApp, LabelApp, ListApp, MemberApp } from "../Kintone";
jest.mock("@kintone/rest-api-client");
// jest.mock("node-fetch");
var KintoneMock = KintoneRestAPIClient;
describe("getRecordIdFromCardのテスト", function () {
    var testcases = [
        {
            name: "見つかったidのレコードidを返す",
            mockReturn: {
                records: [
                    {
                        $id: {
                            value: "aaa",
                        },
                    },
                ],
            },
            expected: "aaa",
        },
        {
            name: "レコードが存在しない場合のundefindを返す",
            mockReturn: {
                records: [],
            },
            expected: undefined,
        },
    ];
    var _loop_1 = function (name, mockReturn, expected) {
        test(name, function () { return __awaiter(void 0, void 0, void 0, function () {
            var k, actual;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        KintoneMock.mockImplementationOnce(function () {
                            return {
                                record: {
                                    getRecords: function () {
                                        return mockReturn;
                                    },
                                },
                            };
                        });
                        k = new KintoneMock();
                        return [4 /*yield*/, ApiExecutor.getRecordIdFromCard(k, "", {
                                card: { id: "" },
                            })];
                    case 1:
                        actual = _a.sent();
                        expect(actual).toEqual(expected);
                        return [2 /*return*/];
                }
            });
        }); });
    };
    for (var _i = 0, testcases_1 = testcases; _i < testcases_1.length; _i++) {
        var _a = testcases_1[_i], name = _a.name, mockReturn = _a.mockReturn, expected = _a.expected;
        _loop_1(name, mockReturn, expected);
    }
});
describe("getRecordIdFromListのテスト", function () {
    var testcases = [
        {
            name: "見つかったidのレコードidを返す(list)",
            mockReturn: {
                records: [
                    {
                        $id: {
                            value: "aaa",
                        },
                    },
                ],
            },
            input: {
                list: {
                    id: "",
                },
            },
            expected: "aaa",
        },
        {
            name: "見つかったidのレコードidを返す(listAfter)",
            mockReturn: {
                records: [
                    {
                        $id: {
                            value: "aaa",
                        },
                    },
                ],
            },
            input: {
                listAfter: {
                    id: "",
                },
            },
            expected: "aaa",
        },
        {
            name: "listもlistAfterもない場合undefindを返す",
            mockReturn: {
                records: [
                    {
                        $id: {
                            value: "aaa",
                        },
                    },
                ],
            },
            input: {},
            expected: undefined,
        },
        {
            name: "レコードが存在しない場合のundefindを返す",
            mockReturn: {
                records: [],
            },
            input: {
                list: {
                    id: "",
                },
            },
            expected: undefined,
        },
    ];
    var _loop_2 = function (name, mockReturn, input, expected) {
        test(name, function () { return __awaiter(void 0, void 0, void 0, function () {
            var k, actual;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        KintoneMock.mockImplementationOnce(function () {
                            return {
                                record: {
                                    getRecords: function () {
                                        return mockReturn;
                                    },
                                },
                            };
                        });
                        k = new KintoneMock();
                        return [4 /*yield*/, ApiExecutor.getRecordIdFromList(k, "", input)];
                    case 1:
                        actual = _a.sent();
                        expect(actual).toEqual(expected);
                        return [2 /*return*/];
                }
            });
        }); });
    };
    for (var _i = 0, testcases_2 = testcases; _i < testcases_2.length; _i++) {
        var _a = testcases_2[_i], name = _a.name, mockReturn = _a.mockReturn, input = _a.input, expected = _a.expected;
        _loop_2(name, mockReturn, input, expected);
    }
});
describe("getRecordIdFromLabelOfSameのテスト", function () {
    var testcases = [
        {
            name: "見つかったidのレコードidを返す",
            mockReturn: {
                records: [
                    {
                        $id: {
                            value: "aaa",
                        },
                    },
                ],
            },
            expected: "aaa",
        },
        {
            name: "レコードが存在しない場合のundefindを返す",
            mockReturn: {
                records: [],
            },
            expected: undefined,
        },
    ];
    var _loop_3 = function (name, mockReturn, expected) {
        test(name, function () { return __awaiter(void 0, void 0, void 0, function () {
            var k, actual;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        KintoneMock.mockImplementationOnce(function () {
                            return {
                                record: {
                                    getRecords: function () {
                                        return mockReturn;
                                    },
                                },
                            };
                        });
                        k = new KintoneMock();
                        return [4 /*yield*/, ApiExecutor.getRecordIdFromLabelOfSame(k, "", {
                                label: { id: "" },
                            })];
                    case 1:
                        actual = _a.sent();
                        expect(actual).toEqual(expected);
                        return [2 /*return*/];
                }
            });
        }); });
    };
    for (var _i = 0, testcases_3 = testcases; _i < testcases_3.length; _i++) {
        var _a = testcases_3[_i], name = _a.name, mockReturn = _a.mockReturn, expected = _a.expected;
        _loop_3(name, mockReturn, expected);
    }
});
describe("getKintoneUserCodeのテスト", function () {
    var _a;
    var testcases = [
        {
            name: "見つかったidのkintoneユーザーコードを返す",
            mockReturn: {
                records: [
                    (_a = {
                            $id: {
                                value: "aaa",
                            }
                        },
                        _a[MemberApp.kintoneUser] = {
                            value: [
                                {
                                    code: "kintone code",
                                    name: "",
                                },
                            ],
                        },
                        _a),
                ],
            },
            expected: "kintone code",
        },
        {
            name: "レコードが存在しない場合のundefindを返す",
            mockReturn: {
                records: [],
            },
            expected: undefined,
        },
    ];
    var _loop_4 = function (name, mockReturn, expected) {
        test(name, function () { return __awaiter(void 0, void 0, void 0, function () {
            var k, actual;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        KintoneMock.mockImplementationOnce(function () {
                            return {
                                record: {
                                    getRecords: function () {
                                        return mockReturn;
                                    },
                                },
                            };
                        });
                        k = new KintoneMock();
                        return [4 /*yield*/, ApiExecutor.getKintoneUserCode(k, "", {
                                member: { id: "" },
                            })];
                    case 1:
                        actual = _a.sent();
                        expect(actual).toEqual(expected);
                        return [2 /*return*/];
                }
            });
        }); });
    };
    for (var _i = 0, testcases_4 = testcases; _i < testcases_4.length; _i++) {
        var _b = testcases_4[_i], name = _b.name, mockReturn = _b.mockReturn, expected = _b.expected;
        _loop_4(name, mockReturn, expected);
    }
});
describe("getKintoneUserCodesOfSettedのテスト", function () {
    var _a;
    var testcases = [
        {
            name: "見つかったidのkintoneユーザーコードを返す",
            mockReturn: {
                records: [
                    (_a = {
                            $id: {
                                value: "aaa",
                            }
                        },
                        _a[CardApp.member] = {
                            value: [
                                {
                                    code: "kintone code 1",
                                    name: "",
                                },
                                {
                                    code: "kintone code 2",
                                    name: "",
                                },
                            ],
                        },
                        _a),
                ],
            },
            expected: ["kintone code 1", "kintone code 2"],
        },
        {
            name: "レコードが存在しない場合のundefindを返す",
            mockReturn: {
                records: [],
            },
            expected: [],
        },
    ];
    var _loop_5 = function (name, mockReturn, expected) {
        test(name, function () { return __awaiter(void 0, void 0, void 0, function () {
            var k, actual;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        KintoneMock.mockImplementationOnce(function () {
                            return {
                                record: {
                                    getRecords: function () {
                                        return mockReturn;
                                    },
                                },
                            };
                        });
                        k = new KintoneMock();
                        return [4 /*yield*/, ApiExecutor.getKintoneUserCodesOfSetted(k, "", {
                                card: { id: "" },
                            })];
                    case 1:
                        actual = _a.sent();
                        expect(actual).toEqual(expected);
                        return [2 /*return*/];
                }
            });
        }); });
    };
    for (var _i = 0, testcases_5 = testcases; _i < testcases_5.length; _i++) {
        var _b = testcases_5[_i], name = _b.name, mockReturn = _b.mockReturn, expected = _b.expected;
        _loop_5(name, mockReturn, expected);
    }
});
describe("getRecordIdAndLabelIdsFromCardのテスト", function () {
    var _a;
    var testcases = [
        {
            name: "見つかったidのレコードidとtableIdsを返す",
            mockReturn: {
                records: [
                    (_a = {
                            $id: {
                                value: "aaa",
                            }
                        },
                        _a[CardApp.labelTable] = {
                            value: [
                                { id: "1", value: { LABEL_ID: "aaa", LABEL_NAME: "label_1" } },
                                { id: "2", value: { LABEL_ID: "bbb", LABEL_NAME: "label_2" } },
                            ],
                        },
                        _a),
                ],
            },
            expected: {
                recordId: "aaa",
                tableIds: [
                    { id: "1", value: { LABEL_ID: "aaa", LABEL_NAME: "label_1" } },
                    { id: "2", value: { LABEL_ID: "bbb", LABEL_NAME: "label_2" } },
                ],
            },
        },
        {
            name: "レコードが存在しない場合のundefindを返す",
            mockReturn: {
                records: [],
            },
            expected: undefined,
        },
    ];
    var _loop_6 = function (name, mockReturn, expected) {
        test(name, function () { return __awaiter(void 0, void 0, void 0, function () {
            var k, actual;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        KintoneMock.mockImplementationOnce(function () {
                            return {
                                record: {
                                    getRecords: function () {
                                        return mockReturn;
                                    },
                                },
                            };
                        });
                        k = new KintoneMock();
                        return [4 /*yield*/, ApiExecutor.getRecordIdAndLabelIdsFromCard(k, "", {
                                card: { id: "" },
                            })];
                    case 1:
                        actual = _a.sent();
                        expect(actual).toEqual(expected);
                        return [2 /*return*/];
                }
            });
        }); });
    };
    for (var _i = 0, testcases_6 = testcases; _i < testcases_6.length; _i++) {
        var _b = testcases_6[_i], name = _b.name, mockReturn = _b.mockReturn, expected = _b.expected;
        _loop_6(name, mockReturn, expected);
    }
});
describe("addMemberのテスト", function () {
    var _a;
    var testcases = [
        {
            name: "RecordParamに入るべき値が正しい",
            mockReturn: {},
            expected: {
                app: "appId",
                record: (_a = {},
                    _a[MemberApp.trelloId] = { value: "id" },
                    _a[MemberApp.name] = { value: "name" },
                    _a[MemberApp.kintoneUser] = {
                        value: [{ code: "kintoneUserCode" }],
                    },
                    _a),
            },
        },
    ];
    var _loop_7 = function (name, mockReturn, expected) {
        test(name, function () { return __awaiter(void 0, void 0, void 0, function () {
            var k, actual;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        KintoneMock.mockImplementationOnce(function () {
                            return {
                                record: {
                                    addRecord: function () {
                                        return Promise.resolve(mockReturn);
                                    },
                                },
                            };
                        });
                        k = new KintoneMock();
                        return [4 /*yield*/, ApiExecutor.addMember(k, "appId", {
                                member: { id: "id", name: "name" },
                            }, "kintoneUserCode")];
                    case 1:
                        actual = _a.sent();
                        expect(actual).toEqual(expected);
                        return [2 /*return*/];
                }
            });
        }); });
    };
    for (var _i = 0, testcases_7 = testcases; _i < testcases_7.length; _i++) {
        var _b = testcases_7[_i], name = _b.name, mockReturn = _b.mockReturn, expected = _b.expected;
        _loop_7(name, mockReturn, expected);
    }
});
describe("createCardのテスト", function () {
    var _a, _b;
    var testcases = [
        {
            name: "RecordParamに入るべき値が正しい",
            input: { card: { id: "id", name: "name", shortLink: "anyLink" } },
            expected: {
                app: "appId",
                record: (_a = {},
                    _a[CardApp.id] = { value: "id" },
                    _a[CardApp.name] = { value: "name" },
                    _a[CardApp.link] = { value: "https://trello.com/c/anyLink" },
                    _a),
            },
        },
        {
            name: "trelloイベントにlistがあったらRecordParamにlistも入る",
            input: {
                card: { id: "id", name: "name", shortLink: "anyLink" },
                list: { id: "listId" },
            },
            expected: {
                app: "appId",
                record: (_b = {},
                    _b[CardApp.id] = { value: "id" },
                    _b[CardApp.name] = { value: "name" },
                    _b[CardApp.link] = { value: "https://trello.com/c/anyLink" },
                    _b[CardApp.idList] = { value: "listId" },
                    _b),
            },
        },
    ];
    var _loop_8 = function (name, input, expected) {
        test(name, function () { return __awaiter(void 0, void 0, void 0, function () {
            var k, actual;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        KintoneMock.mockImplementationOnce(function () {
                            return {
                                record: {
                                    addRecord: function () {
                                        return Promise.resolve({});
                                    },
                                },
                            };
                        });
                        k = new KintoneMock();
                        return [4 /*yield*/, ApiExecutor.createCard(k, "appId", input)];
                    case 1:
                        actual = _a.sent();
                        expect(actual).toEqual(expected);
                        return [2 /*return*/];
                }
            });
        }); });
    };
    for (var _i = 0, testcases_8 = testcases; _i < testcases_8.length; _i++) {
        var _c = testcases_8[_i], name = _c.name, input = _c.input, expected = _c.expected;
        _loop_8(name, input, expected);
    }
});
describe("updateCardのテスト", function () {
    var _a, _b;
    var testcases = [
        {
            name: "oldにキーがある場合recordにもキーが含まれる",
            input1: {
                card: { id: "id", name: "name", desc: "desc" },
                old: { id: "oldId", name: "oldName", desc: "oldDesc" },
            },
            input2: "recordId",
            expected: (_a = {},
                _a[CardApp.id] = { value: "id" },
                _a[CardApp.name] = { value: "name" },
                _a[CardApp.desc] = { value: "desc" },
                _a),
        },
        {
            name: "oldにキーがない場合recordにキーは含まれない",
            input1: {
                card: { id: "id", name: "name", desc: "desc" },
                old: { name: "oldName", desc: "oldDesc" },
            },
            input2: "recordId",
            expected: (_b = {},
                _b[CardApp.name] = { value: "name" },
                _b[CardApp.desc] = { value: "desc" },
                _b),
        },
    ];
    var _loop_9 = function (name, input1, input2, expected) {
        test(name, function () { return __awaiter(void 0, void 0, void 0, function () {
            var k, actual;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        KintoneMock.mockImplementationOnce(function () {
                            return {
                                record: {
                                    updateRecord: function () {
                                        return Promise.resolve({});
                                    },
                                },
                            };
                        });
                        k = new KintoneMock();
                        return [4 /*yield*/, ApiExecutor.updateCard(k, "appId", input1, input2)];
                    case 1:
                        actual = _a.sent();
                        expect(actual).toEqual(expected);
                        return [2 /*return*/];
                }
            });
        }); });
    };
    for (var _i = 0, testcases_9 = testcases; _i < testcases_9.length; _i++) {
        var _c = testcases_9[_i], name = _c.name, input1 = _c.input1, input2 = _c.input2, expected = _c.expected;
        _loop_9(name, input1, input2, expected);
    }
});
describe("createListのテスト", function () {
    var _a, _b;
    var testcases = [
        {
            name: "RecordParamに入るべき値が正しい",
            input: { list: { id: "id", name: "name" } },
            expected: {
                app: "appId",
                record: (_a = {},
                    _a[ListApp.id] = { value: "id" },
                    _a[ListApp.name] = { value: "name" },
                    _a),
            },
        },
        {
            name: "listAfterでも入力できる",
            input: { listAfter: { id: "id", name: "name" } },
            expected: {
                app: "appId",
                record: (_b = {},
                    _b[ListApp.id] = { value: "id" },
                    _b[ListApp.name] = { value: "name" },
                    _b),
            },
        },
    ];
    var _loop_10 = function (name, input, expected) {
        test(name, function () { return __awaiter(void 0, void 0, void 0, function () {
            var k, actual;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        KintoneMock.mockImplementationOnce(function () {
                            return {
                                record: {
                                    addRecord: function () {
                                        return Promise.resolve({});
                                    },
                                },
                            };
                        });
                        k = new KintoneMock();
                        return [4 /*yield*/, ApiExecutor.createList(k, "appId", input)];
                    case 1:
                        actual = _a.sent();
                        expect(actual).toEqual(expected);
                        return [2 /*return*/];
                }
            });
        }); });
    };
    for (var _i = 0, testcases_10 = testcases; _i < testcases_10.length; _i++) {
        var _c = testcases_10[_i], name = _c.name, input = _c.input, expected = _c.expected;
        _loop_10(name, input, expected);
    }
});
describe("updateListのテスト", function () {
    var _a, _b;
    var testcases = [
        {
            name: "oldにキーがある場合recordにもキーが含まれる",
            input1: {
                list: { id: "id", name: "name" },
                old: { id: "oldId", name: "oldName" },
            },
            input2: "recordId",
            expected: (_a = {},
                _a[ListApp.id] = { value: "id" },
                _a[ListApp.name] = { value: "name" },
                _a),
        },
        {
            name: "oldにキーがない場合recordにキーは含まれない",
            input1: {
                list: { id: "id", name: "name" },
                old: { name: "oldName" },
            },
            input2: "recordId",
            expected: (_b = {},
                _b[ListApp.name] = { value: "name" },
                _b),
        },
    ];
    var _loop_11 = function (name, input1, input2, expected) {
        test(name, function () { return __awaiter(void 0, void 0, void 0, function () {
            var k, actual;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        KintoneMock.mockImplementationOnce(function () {
                            return {
                                record: {
                                    updateRecord: function () {
                                        return Promise.resolve({});
                                    },
                                },
                            };
                        });
                        k = new KintoneMock();
                        return [4 /*yield*/, ApiExecutor.updateList(k, "appId", input1, input2)];
                    case 1:
                        actual = _a.sent();
                        expect(actual).toEqual(expected);
                        return [2 /*return*/];
                }
            });
        }); });
    };
    for (var _i = 0, testcases_11 = testcases; _i < testcases_11.length; _i++) {
        var _c = testcases_11[_i], name = _c.name, input1 = _c.input1, input2 = _c.input2, expected = _c.expected;
        _loop_11(name, input1, input2, expected);
    }
});
describe("createLabelのテスト", function () {
    var _a;
    var testcases = [
        {
            name: "RecordParamに入るべき値が正しい",
            input: { label: { id: "id", name: "name", color: "color" } },
            expected: {
                app: "appId",
                record: (_a = {},
                    _a[LabelApp.id] = { value: "id" },
                    _a[LabelApp.name] = { value: "name" },
                    _a[LabelApp.color] = { value: "color" },
                    _a),
            },
        },
    ];
    var _loop_12 = function (name, input, expected) {
        test(name, function () { return __awaiter(void 0, void 0, void 0, function () {
            var k, actual;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        KintoneMock.mockImplementationOnce(function () {
                            return {
                                record: {
                                    addRecord: function () {
                                        return Promise.resolve({});
                                    },
                                },
                            };
                        });
                        k = new KintoneMock();
                        return [4 /*yield*/, ApiExecutor.createLabel(k, "appId", input)];
                    case 1:
                        actual = _a.sent();
                        expect(actual).toEqual(expected);
                        return [2 /*return*/];
                }
            });
        }); });
    };
    for (var _i = 0, testcases_12 = testcases; _i < testcases_12.length; _i++) {
        var _b = testcases_12[_i], name = _b.name, input = _b.input, expected = _b.expected;
        _loop_12(name, input, expected);
    }
});
describe("updateLabelのテスト", function () {
    var _a;
    var testcases = [
        {
            name: "oldにキーがある場合recordにもキーが含まれる",
            input1: {
                label: { name: "name", color: "color" },
            },
            input2: "recordId",
            expected: {
                app: "appId",
                id: "recordId",
                record: (_a = {},
                    _a[LabelApp.name] = { value: "name" },
                    _a[LabelApp.color] = { value: "color" },
                    _a),
            },
        },
    ];
    var _loop_13 = function (name, input1, input2, expected) {
        test(name, function () { return __awaiter(void 0, void 0, void 0, function () {
            var k, actual;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        KintoneMock.mockImplementationOnce(function () {
                            return {
                                record: {
                                    updateRecord: function () {
                                        return Promise.resolve({});
                                    },
                                },
                            };
                        });
                        k = new KintoneMock();
                        return [4 /*yield*/, ApiExecutor.updateLabel(k, "appId", input1, input2)];
                    case 1:
                        actual = _a.sent();
                        expect(actual).toEqual(expected);
                        return [2 /*return*/];
                }
            });
        }); });
    };
    for (var _i = 0, testcases_13 = testcases; _i < testcases_13.length; _i++) {
        var _b = testcases_13[_i], name = _b.name, input1 = _b.input1, input2 = _b.input2, expected = _b.expected;
        _loop_13(name, input1, input2, expected);
    }
});
describe("addLabelToCardのテスト", function () {
    var _a, _b;
    var testcases = [
        {
            name: "RecordParamに入るべき値が正しい",
            input1: {
                label: { id: "id", name: "name", color: "color" },
            },
            input2: "recordId",
            input3: [
                {
                    id: "alreadyLabelId1",
                    value: { LABEL_ID: "alreadyLabelId1", LABEL_NAME: "red" },
                },
                {
                    id: "alreadyLabelId2",
                    value: { LABEL_ID: "alreadyLabelId2", LABEL_NAME: "blue" },
                },
            ],
            expected: {
                app: "appId",
                id: "recordId",
                record: (_a = {},
                    _a[CardApp.labelTable] = {
                        value: [
                            { id: "alreadyLabelId1" },
                            { id: "alreadyLabelId2" },
                            {
                                value: (_b = {},
                                    _b[CardApp.labelId] = "id",
                                    _b),
                            },
                        ],
                    },
                    _a),
            },
        },
    ];
    var _loop_14 = function (name, input1, input2, input3, expected) {
        test(name, function () { return __awaiter(void 0, void 0, void 0, function () {
            var k, actual;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        KintoneMock.mockImplementationOnce(function () {
                            return {
                                record: {
                                    updateRecord: function () {
                                        return Promise.resolve({});
                                    },
                                },
                            };
                        });
                        k = new KintoneMock();
                        return [4 /*yield*/, ApiExecutor.addLabelToCard(k, "appId", input1, input2, input3)];
                    case 1:
                        actual = _a.sent();
                        expect(actual).toEqual(expected);
                        return [2 /*return*/];
                }
            });
        }); });
    };
    for (var _i = 0, testcases_14 = testcases; _i < testcases_14.length; _i++) {
        var _c = testcases_14[_i], name = _c.name, input1 = _c.input1, input2 = _c.input2, input3 = _c.input3, expected = _c.expected;
        _loop_14(name, input1, input2, input3, expected);
    }
});
describe("addMemberToCardのテスト", function () {
    var _a;
    var testcases = [
        {
            name: "RecordParamに入るべき値が正しい",
            input1: "appId",
            input2: "cardId",
            input3: "kintoneUserCode",
            input4: ["alreadyKintoneUser1", "alreadyKintoneUser2"],
            expected: {
                app: "appId",
                id: "cardId",
                record: (_a = {},
                    _a[CardApp.member] = {
                        value: [
                            { code: "alreadyKintoneUser1" },
                            { code: "alreadyKintoneUser2" },
                            {
                                code: "kintoneUserCode",
                            },
                        ],
                    },
                    _a),
            },
        },
    ];
    var _loop_15 = function (name, input1, input2, input3, input4, expected) {
        test(name, function () { return __awaiter(void 0, void 0, void 0, function () {
            var k, actual;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        KintoneMock.mockImplementationOnce(function () {
                            return {
                                record: {
                                    updateRecord: function () {
                                        return Promise.resolve({});
                                    },
                                },
                            };
                        });
                        k = new KintoneMock();
                        return [4 /*yield*/, ApiExecutor.addMemberToCard(k, input1, input2, input3, input4)];
                    case 1:
                        actual = _a.sent();
                        expect(actual).toEqual(expected);
                        return [2 /*return*/];
                }
            });
        }); });
    };
    for (var _i = 0, testcases_15 = testcases; _i < testcases_15.length; _i++) {
        var _b = testcases_15[_i], name = _b.name, input1 = _b.input1, input2 = _b.input2, input3 = _b.input3, input4 = _b.input4, expected = _b.expected;
        _loop_15(name, input1, input2, input3, input4, expected);
    }
});
describe("removeMemberFromCardのテスト", function () {
    var _a;
    var testcases = [
        {
            name: "RecordParamに入るべき値が正しい",
            input1: "appId",
            input2: "cardId",
            input3: "kintoneUserCode",
            input4: ["alreadyKintoneUser1", "alreadyKintoneUser2"],
            expected: {
                app: "appId",
                id: "cardId",
                record: (_a = {},
                    _a[CardApp.member] = {
                        value: [
                            { code: "alreadyKintoneUser1" },
                            { code: "alreadyKintoneUser2" },
                        ],
                    },
                    _a),
            },
        },
    ];
    var _loop_16 = function (name, input1, input2, input3, input4, expected) {
        test(name, function () { return __awaiter(void 0, void 0, void 0, function () {
            var k, actual;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        KintoneMock.mockImplementationOnce(function () {
                            return {
                                record: {
                                    updateRecord: function () {
                                        return Promise.resolve({});
                                    },
                                },
                            };
                        });
                        k = new KintoneMock();
                        return [4 /*yield*/, ApiExecutor.removeMemberFromCard(k, input1, input2, input3, input4)];
                    case 1:
                        actual = _a.sent();
                        expect(actual).toEqual(expected);
                        return [2 /*return*/];
                }
            });
        }); });
    };
    for (var _i = 0, testcases_16 = testcases; _i < testcases_16.length; _i++) {
        var _b = testcases_16[_i], name = _b.name, input1 = _b.input1, input2 = _b.input2, input3 = _b.input3, input4 = _b.input4, expected = _b.expected;
        _loop_16(name, input1, input2, input3, input4, expected);
    }
});
describe("registerRecordIdToTrelloのテスト", function () {
    var testcases = [
        {
            name: "RecordParamに入るべき値が正しい",
            input: { card: { id: "id", name: "name", shortLink: "anyLink" } },
            expected: {
                status: 200,
                statusText: "OK",
                text: "ok text",
                url: "https://api.trello.com/1/cards/cardID/attachments?key=trelloApiKey&token=trelloApiToken&name=EPTRE-13&url=https%3A%2F%2Fexample.com%2Fk%2F32%2Fshow%23record%3D13",
            },
        },
    ];
    var _loop_17 = function (name, input, expected) {
        test(name, function () { return __awaiter(void 0, void 0, void 0, function () {
            var actual;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        jest.mock("node-fetch", function () {
                            return function (url) {
                                return Promise.resolve({
                                    status: 200,
                                    statusText: "OK",
                                    text: function () {
                                        return "ok text";
                                    },
                                    url: url,
                                });
                            };
                        });
                        return [4 /*yield*/, ApiExecutor.registerRecordIdToTrello("cardID", "https://example.com/", "32", "trelloApiKey", "trelloApiToken", "13", "EPTRE")];
                    case 1:
                        actual = _a.sent();
                        expect(actual).toEqual(expected);
                        return [2 /*return*/];
                }
            });
        }); });
    };
    for (var _i = 0, testcases_17 = testcases; _i < testcases_17.length; _i++) {
        var _a = testcases_17[_i], name = _a.name, input = _a.input, expected = _a.expected;
        _loop_17(name, input, expected);
    }
});
describe("addRecordIdToCardNameOfTrelloのテスト", function () {
    var testcases = [
        {
            name: "カード名にIDがつく",
            input: {
                nowCardName: "カード名だよ",
                eptreId: "123",
            },
            expected: {
                newName: "EPTRE-123: カード名だよ",
                status: 200,
                statusText: "OK",
                text: "ok text",
                url: "https://api.trello.com/1/cards/cardId?key=trelloApiKey&token=trelloApiToken&name=EPTRE-123:%20%E3%82%AB%E3%83%BC%E3%83%89%E5%90%8D%E3%81%A0%E3%82%88",
            },
        },
        {
            name: "カード名にすでに同じIDがついてるのでスキップする",
            input: {
                nowCardName: "EPTRE-123: カード名だよ",
                eptreId: "123",
            },
            expected: undefined,
        },
        {
            name: "カード名に別のIDがついてるので上書きする",
            input: {
                nowCardName: "EPTRE-123: カード名だよ(コピー)",
                eptreId: "125",
            },
            expected: {
                newName: "EPTRE-125: カード名だよ(コピー)",
                status: 200,
                statusText: "OK",
                text: "ok text",
                url: "https://api.trello.com/1/cards/cardId?key=trelloApiKey&token=trelloApiToken&name=EPTRE-125:%20%E3%82%AB%E3%83%BC%E3%83%89%E5%90%8D%E3%81%A0%E3%82%88(%E3%82%B3%E3%83%94%E3%83%BC)",
            },
        },
        {
            name: "カード名に別のIDがついてるが先頭じゃないので無視する",
            input: {
                nowCardName: "EPTRE-123をぶっ壊す",
                eptreId: "126",
            },
            expected: {
                newName: "EPTRE-126: EPTRE-123をぶっ壊す",
                status: 200,
                statusText: "OK",
                text: "ok text",
                url: "https://api.trello.com/1/cards/cardId?key=trelloApiKey&token=trelloApiToken&name=EPTRE-126:%20EPTRE-123%E3%82%92%E3%81%B6%E3%81%A3%E5%A3%8A%E3%81%99",
            },
        },
        {
            name: "カード名にアンパサントが含まれている場合、全角に直す",
            input: {
                nowCardName: "ああああヒアリング & ああああああナイトについて考える",
                eptreId: "126",
            },
            expected: {
                newName: "EPTRE-126: ああああヒアリング ＆ ああああああナイトについて考える",
                status: 200,
                statusText: "OK",
                text: "ok text",
                url: "https://api.trello.com/1/cards/cardId?key=trelloApiKey&token=trelloApiToken&name=EPTRE-126:%20%E3%81%82%E3%81%82%E3%81%82%E3%81%82%E3%83%92%E3%82%A2%E3%83%AA%E3%83%B3%E3%82%B0%20%EF%BC%86%20%E3%81%82%E3%81%82%E3%81%82%E3%81%82%E3%81%82%E3%81%82%E3%83%8A%E3%82%A4%E3%83%88%E3%81%AB%E3%81%A4%E3%81%84%E3%81%A6%E8%80%83%E3%81%88%E3%82%8B",
            },
        },
        {
            name: "カード名に複数のアンパサントが含まれている場合、全角に直す",
            input: {
                nowCardName: "ああああヒアリング & ああああああナイト & aaaについて考える",
                eptreId: "126",
            },
            expected: {
                newName: "EPTRE-126: ああああヒアリング ＆ ああああああナイト ＆ aaaについて考える",
                status: 200,
                statusText: "OK",
                text: "ok text",
                url: "https://api.trello.com/1/cards/cardId?key=trelloApiKey&token=trelloApiToken&name=EPTRE-126:%20%E3%81%82%E3%81%82%E3%81%82%E3%81%82%E3%83%92%E3%82%A2%E3%83%AA%E3%83%B3%E3%82%B0%20%EF%BC%86%20%E3%81%82%E3%81%82%E3%81%82%E3%81%82%E3%81%82%E3%81%82%E3%83%8A%E3%82%A4%E3%83%88%20%EF%BC%86%20aaa%E3%81%AB%E3%81%A4%E3%81%84%E3%81%A6%E8%80%83%E3%81%88%E3%82%8B",
            },
        },
        {
            name: "カード名にハッシュ(#)が含まれている場合、全角に直す",
            input: {
                nowCardName: "ああああヒアリング #1 ああああああナイトについて考える",
                eptreId: "126",
            },
            expected: {
                newName: "EPTRE-126: ああああヒアリング ＃1 ああああああナイトについて考える",
                status: 200,
                statusText: "OK",
                text: "ok text",
                url: "https://api.trello.com/1/cards/cardId?key=trelloApiKey&token=trelloApiToken&name=EPTRE-126:%20%E3%81%82%E3%81%82%E3%81%82%E3%81%82%E3%83%92%E3%82%A2%E3%83%AA%E3%83%B3%E3%82%B0%20%EF%BC%831%20%E3%81%82%E3%81%82%E3%81%82%E3%81%82%E3%81%82%E3%81%82%E3%83%8A%E3%82%A4%E3%83%88%E3%81%AB%E3%81%A4%E3%81%84%E3%81%A6%E8%80%83%E3%81%88%E3%82%8B",
            },
        },
        {
            name: "カード名に複数のハッシュ(#)が含まれている場合、全角に直す",
            input: {
                nowCardName: "ああああヒアリング #1 ああああああナイト # aaaについて考える",
                eptreId: "126",
            },
            expected: {
                newName: "EPTRE-126: ああああヒアリング ＃1 ああああああナイト ＃ aaaについて考える",
                status: 200,
                statusText: "OK",
                text: "ok text",
                url: "https://api.trello.com/1/cards/cardId?key=trelloApiKey&token=trelloApiToken&name=EPTRE-126:%20%E3%81%82%E3%81%82%E3%81%82%E3%81%82%E3%83%92%E3%82%A2%E3%83%AA%E3%83%B3%E3%82%B0%20%EF%BC%831%20%E3%81%82%E3%81%82%E3%81%82%E3%81%82%E3%81%82%E3%81%82%E3%83%8A%E3%82%A4%E3%83%88%20%EF%BC%83%20aaa%E3%81%AB%E3%81%A4%E3%81%84%E3%81%A6%E8%80%83%E3%81%88%E3%82%8B",
            },
        },
        {
            name: "カード名にアンパサンドとハッシュ(#)が含まれている場合、全角に直す",
            input: {
                nowCardName: "ああああヒアリング #1 ああああああナイト & aaaについて考える",
                eptreId: "126",
            },
            expected: {
                newName: "EPTRE-126: ああああヒアリング ＃1 ああああああナイト ＆ aaaについて考える",
                status: 200,
                statusText: "OK",
                text: "ok text",
                url: "https://api.trello.com/1/cards/cardId?key=trelloApiKey&token=trelloApiToken&name=EPTRE-126:%20%E3%81%82%E3%81%82%E3%81%82%E3%81%82%E3%83%92%E3%82%A2%E3%83%AA%E3%83%B3%E3%82%B0%20%EF%BC%831%20%E3%81%82%E3%81%82%E3%81%82%E3%81%82%E3%81%82%E3%81%82%E3%83%8A%E3%82%A4%E3%83%88%20%EF%BC%86%20aaa%E3%81%AB%E3%81%A4%E3%81%84%E3%81%A6%E8%80%83%E3%81%88%E3%82%8B",
            },
        },
    ];
    var _loop_18 = function (name, input, expected) {
        test(name, function () { return __awaiter(void 0, void 0, void 0, function () {
            var actual;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        jest.mock("node-fetch", function () {
                            return function (url) {
                                return Promise.resolve({
                                    status: 200,
                                    statusText: "OK",
                                    text: function () {
                                        return "ok text";
                                    },
                                    url: url,
                                });
                            };
                        });
                        return [4 /*yield*/, ApiExecutor.addRecordIdToCardNameOfTrello("cardId", "trelloApiKey", "trelloApiToken", input.nowCardName, input.eptreId, "EPTRE")];
                    case 1:
                        actual = _a.sent();
                        expect(actual).toEqual(expected);
                        return [2 /*return*/];
                }
            });
        }); });
    };
    for (var _i = 0, testcases_18 = testcases; _i < testcases_18.length; _i++) {
        var _a = testcases_18[_i], name = _a.name, input = _a.input, expected = _a.expected;
        _loop_18(name, input, expected);
    }
});
