"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ApiExecutor = exports.addRecordIdToCardNameOfTrello = exports.registerRecordIdToTrello = void 0;
var Kintone_1 = require("./Kintone");
var urlJoin = require("url-join");
/**
 * Cardアプリからtrelloのカードに一致するレコードIDを取得する
 * @param client
 * @param appId
 * @param data
 */
var getRecordIdFromCard = function (client, appId, data) { return __awaiter(void 0, void 0, void 0, function () {
    var cardId, res, recordId;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                cardId = data.card.id;
                return [4 /*yield*/, client.record.getRecords({
                        app: appId,
                        fields: ["$id"],
                        query: Kintone_1.CardApp.id + "=\"" + cardId + "\"",
                    })];
            case 1:
                res = _a.sent();
                if (res.records.length === 0) {
                    return [2 /*return*/, undefined];
                }
                recordId = res.records[0].$id.value !== null
                    ? res.records[0].$id.value.toString()
                    : "";
                console.info("getRecordIdFromCard\nCard record ID: " + recordId);
                return [2 /*return*/, recordId];
        }
    });
}); };
/**
 * Listアプリからtrelloのリストに一致するレコードIDを取得する
 * @param client
 * @param appId
 * @param data
 */
var getRecordIdFromList = function (client, appId, data) { return __awaiter(void 0, void 0, void 0, function () {
    var listValue, res, recordId;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                listValue = typeof data.list === "object" ? data.list : data.listAfter;
                if (listValue === undefined) {
                    return [2 /*return*/, undefined];
                }
                return [4 /*yield*/, client.record.getRecords({
                        app: appId,
                        fields: ["$id"],
                        query: Kintone_1.ListApp.id + "=\"" + listValue.id + "\"",
                    })];
            case 1:
                res = _a.sent();
                if (res.records.length === 0) {
                    return [2 /*return*/, undefined];
                }
                recordId = res.records[0].$id.value !== null
                    ? res.records[0].$id.value.toString()
                    : "";
                console.info("getRecordIdFromList\nList record ID: " + recordId);
                return [2 /*return*/, recordId];
        }
    });
}); };
/**
 * ラベルアプリからラベルのIDを取得する
 * @param client
 * @param appId
 * @param data
 */
var getRecordIdFromLabelOfSame = function (client, appId, data) { return __awaiter(void 0, void 0, void 0, function () {
    var labelId, res, recordId;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                labelId = data.label.id;
                return [4 /*yield*/, client.record.getRecords({
                        app: appId,
                        fields: ["$id"],
                        query: Kintone_1.LabelApp.id + "=\"" + labelId + "\"",
                    })];
            case 1:
                res = _a.sent();
                if (res.records.length === 0) {
                    return [2 /*return*/, undefined];
                }
                recordId = res.records[0].$id.value !== null
                    ? res.records[0].$id.value.toString()
                    : "";
                console.info("getRecordIdFromLabelOfSame\nLabel record ID: " + recordId);
                return [2 /*return*/, recordId];
        }
    });
}); };
/**
 * trelloのIDに紐づいてるkintoneのユーザコードを取得する
 * @param client
 * @param appId
 * @param data
 */
var getKintoneUserCode = function (client, appId, data) { return __awaiter(void 0, void 0, void 0, function () {
    var memberId, res, kintoneUsers, kintoneUser, kintoneUserCode;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                memberId = data.member.id;
                return [4 /*yield*/, client.record.getRecords({
                        app: appId,
                        fields: [Kintone_1.MemberApp.kintoneUser],
                        query: Kintone_1.MemberApp.trelloId + "=\"" + memberId + "\"",
                    })];
            case 1:
                res = _a.sent();
                if (res.records.length === 0) {
                    return [2 /*return*/, undefined];
                }
                kintoneUsers = res.records[0][Kintone_1.MemberApp.kintoneUser].value;
                kintoneUser = kintoneUsers !== null
                    ? kintoneUsers[0]
                    : { code: "", name: "" };
                kintoneUserCode = kintoneUser.code;
                console.info("getKintoneUserCode\nkintone user code: " + kintoneUserCode);
                return [2 /*return*/, kintoneUserCode];
        }
    });
}); };
/**
 * すでにアサインされているkintoneユーザのcodeを取得する
 * @param client
 * @param appId
 * @param data
 */
var getKintoneUserCodesOfSetted = function (client, appId, data) { return __awaiter(void 0, void 0, void 0, function () {
    var cardId, res, members, memberCodes;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                cardId = data.card.id;
                return [4 /*yield*/, client.record.getRecords({
                        app: appId,
                        fields: [Kintone_1.CardApp.member],
                        query: Kintone_1.CardApp.id + "=\"" + cardId + "\"",
                    })];
            case 1:
                res = _a.sent();
                if (res.records.length === 0) {
                    return [2 /*return*/, []];
                }
                members = res.records[0][Kintone_1.CardApp.member].value;
                memberCodes = members.map(function (x) { return x.code; });
                console.info("getKintoneUserCodesOfSetted\nkintone user codes: " + memberCodes.toString());
                return [2 /*return*/, memberCodes];
        }
    });
}); };
/**
 * CardアプリからレコードIDとラベルIDを取得する
 * @param client
 * @param appId
 * @param data
 */
var getRecordIdAndLabelIdsFromCard = function (client, appId, data) { return __awaiter(void 0, void 0, void 0, function () {
    var cardId, res, recordId, labels, tableIds;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                cardId = data.card.id;
                return [4 /*yield*/, client.record.getRecords({
                        app: appId,
                        fields: ["$id", Kintone_1.CardApp.labelTable],
                        query: Kintone_1.CardApp.id + "=\"" + cardId + "\"",
                    })];
            case 1:
                res = _a.sent();
                if (res.records.length === 0) {
                    return [2 /*return*/, undefined];
                }
                recordId = res.records[0].$id.value !== null
                    ? res.records[0].$id.value.toString()
                    : "";
                labels = res.records[0][Kintone_1.CardApp.labelTable].value;
                tableIds = labels.map(function (x) {
                    var _a, _b;
                    return {
                        id: x.id,
                        value: {
                            LABEL_ID: (_a = x.value) === null || _a === void 0 ? void 0 : _a.LABEL_ID,
                            LABEL_NAME: (_b = x.value) === null || _b === void 0 ? void 0 : _b.LABEL_NAME,
                        },
                    };
                });
                console.info("getRecordIdAndLabelIdsFromCard\nCard record ID: " + recordId + "\nCard with label table IDs: " + JSON.stringify(tableIds));
                return [2 /*return*/, { recordId: recordId, tableIds: tableIds }];
        }
    });
}); };
/**
 * CardアプリからレコードIDと添付ファイルのIDを取得する
 * @param client
 * @param appId
 * @param data
 */
var getRecordIdAndAttachmentIdsFromCard = function (client, appId, data) { return __awaiter(void 0, void 0, void 0, function () {
    var cardId, res, recordId, attachments, attachmentsTableIds;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                cardId = data.card.id;
                return [4 /*yield*/, client.record.getRecords({
                        app: appId,
                        fields: ["$id", Kintone_1.CardApp.attachmentTable],
                        query: Kintone_1.CardApp.id + "=\"" + cardId + "\"",
                    })];
            case 1:
                res = _a.sent();
                if (res.records.length === 0) {
                    return [2 /*return*/, undefined];
                }
                recordId = res.records[0].$id.value !== null
                    ? res.records[0].$id.value.toString()
                    : "";
                attachments = res.records[0][Kintone_1.CardApp.attachmentTable].value;
                attachmentsTableIds = attachments.map(function (x) {
                    return {
                        id: x.id,
                    };
                });
                console.info("getRecordIdAndLabelIdsFromCard\nCard record ID: " + recordId + "\nCard with attachment table IDs: " + JSON.stringify(attachmentsTableIds));
                return [2 /*return*/, { recordId: recordId, attachmentsTableIds: attachmentsTableIds }];
        }
    });
}); };
var addMember = function (client, appId, data, kintoneUserId) { return __awaiter(void 0, void 0, void 0, function () {
    var memberId, memberName, addRecordParam;
    var _a;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                memberId = data.member.id;
                memberName = data.member.name;
                addRecordParam = {
                    app: appId,
                    record: (_a = {},
                        _a[Kintone_1.MemberApp.trelloId] = {
                            value: memberId,
                        },
                        _a[Kintone_1.MemberApp.name] = {
                            value: memberName,
                        },
                        _a[Kintone_1.MemberApp.kintoneUser] = {
                            value: [
                                {
                                    code: kintoneUserId,
                                },
                            ],
                        },
                        _a),
                };
                return [4 /*yield*/, client.record.addRecord(addRecordParam).then(function (event) {
                        console.info("addMember\n" + event.id, event.revision);
                    })];
            case 1:
                _b.sent();
                return [2 /*return*/, addRecordParam];
        }
    });
}); };
var createCard = function (client, appId, data) { return __awaiter(void 0, void 0, void 0, function () {
    var addRecordParam, _i, _a, key;
    var _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                addRecordParam = {
                    app: appId,
                    record: (_b = {},
                        _b[Kintone_1.CardApp.name] = {
                            value: data.card.name,
                        },
                        _b[Kintone_1.CardApp.id] = {
                            value: data.card.id,
                        },
                        _b[Kintone_1.CardApp.link] = {
                            value: "https://trello.com/c/" + data.card.shortLink,
                        },
                        _b),
                };
                for (_i = 0, _a = Object.entries(data.card); _i < _a.length; _i++) {
                    key = _a[_i][0];
                    if (Kintone_1.CardApp[key] === undefined)
                        continue;
                    addRecordParam.record[Kintone_1.CardApp[key]] = { value: data.card[key] };
                }
                if (Object.prototype.hasOwnProperty.call(data, "list")) {
                    addRecordParam.record[Kintone_1.CardApp.idList] = {
                        value: data.list.id,
                    };
                }
                return [4 /*yield*/, client.record.addRecord(addRecordParam).then(function (event) {
                        console.info("createCard\n" + event.id, event.revision);
                    })];
            case 1:
                _c.sent();
                return [2 /*return*/, addRecordParam];
        }
    });
}); };
var updateCard = function (client, appId, data, recordId) { return __awaiter(void 0, void 0, void 0, function () {
    var record, _i, _a, key;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                record = {};
                for (_i = 0, _a = Object.entries(data.old); _i < _a.length; _i++) {
                    key = _a[_i][0];
                    record[Kintone_1.CardApp[key]] = { value: data.card[key] };
                }
                return [4 /*yield*/, client.record
                        .updateRecord({
                        app: appId,
                        id: recordId,
                        record: record,
                    })
                        .then(function (event) {
                        console.info("updateCard\nRevision: " + event.revision);
                    })];
            case 1:
                _b.sent();
                return [2 /*return*/, record];
        }
    });
}); };
var updateList = function (client, appId, data, recordId) { return __awaiter(void 0, void 0, void 0, function () {
    var record, _i, _a, key;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                record = {};
                for (_i = 0, _a = Object.entries(data.old); _i < _a.length; _i++) {
                    key = _a[_i][0];
                    record[Kintone_1.ListApp[key]] = {
                        value: data.list[key],
                    };
                }
                return [4 /*yield*/, client.record
                        .updateRecord({
                        app: appId,
                        id: recordId,
                        record: record,
                    })
                        .then(function (event) {
                        console.info("updateList\nRevision: " + event.revision);
                    })];
            case 1:
                _b.sent();
                return [2 /*return*/, record];
        }
    });
}); };
var createList = function (client, appId, data) { return __awaiter(void 0, void 0, void 0, function () {
    var listValue, params;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                listValue = typeof data.list === "object" ? data.list : data.listAfter;
                params = {
                    app: appId,
                    record: {
                        NAME: {
                            value: listValue === null || listValue === void 0 ? void 0 : listValue.name,
                        },
                        ID: {
                            value: listValue === null || listValue === void 0 ? void 0 : listValue.id,
                        },
                    },
                };
                return [4 /*yield*/, client.record.addRecord(params).then(function (event) {
                        console.info("createList\n" + event.id, event.revision);
                    })];
            case 1:
                _a.sent();
                return [2 /*return*/, params];
        }
    });
}); };
var createLabel = function (client, appId, data) { return __awaiter(void 0, void 0, void 0, function () {
    var params;
    var _a;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                params = {
                    app: appId,
                    record: (_a = {},
                        _a[Kintone_1.LabelApp.id] = {
                            value: data.label.id,
                        },
                        _a[Kintone_1.LabelApp.name] = {
                            value: data.label.name,
                        },
                        _a[Kintone_1.LabelApp.color] = {
                            value: data.label.color,
                        },
                        _a),
                };
                return [4 /*yield*/, client.record.addRecord(params).then(function (event) {
                        console.info("createLabel\n" + event.id, event.revision);
                    })];
            case 1:
                _b.sent();
                return [2 /*return*/, params];
        }
    });
}); };
var updateLabel = function (client, appId, data, sameLabelId) { return __awaiter(void 0, void 0, void 0, function () {
    var params;
    var _a;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                params = {
                    app: appId,
                    id: sameLabelId,
                    record: (_a = {},
                        _a[Kintone_1.LabelApp.name] = {
                            value: data.label.name,
                        },
                        _a[Kintone_1.LabelApp.color] = {
                            value: data.label.color,
                        },
                        _a),
                };
                return [4 /*yield*/, client.record.updateRecord(params).then(function (event) {
                        console.info("updateLabel\nRevision: " + event.revision);
                    })];
            case 1:
                _b.sent();
                return [2 /*return*/, params];
        }
    });
}); };
var addLabelToCard = function (client, appId, data, recordId, tableIds) { return __awaiter(void 0, void 0, void 0, function () {
    var tableRecords, params;
    var _a, _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                tableRecords = tableIds.map(function (records) {
                    return {
                        id: records.id.toString(),
                    };
                });
                tableRecords.push({
                    value: (_a = {},
                        _a[Kintone_1.CardApp.labelId] = data.label.id,
                        _a),
                });
                params = {
                    app: appId,
                    id: recordId,
                    record: (_b = {},
                        _b[Kintone_1.CardApp.labelTable] = {
                            value: tableRecords,
                        },
                        _b),
                };
                return [4 /*yield*/, client.record.updateRecord(params)];
            case 1:
                _c.sent();
                return [2 /*return*/, params];
        }
    });
}); };
var removeLabelFromCard = function (client, appId, data, recordId, tableIds) { return __awaiter(void 0, void 0, void 0, function () {
    var tableRecords, params;
    var _a;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                tableRecords = tableIds
                    .filter(function (record) { return record.value.LABEL_ID.value !== data.label.id; })
                    .map(function (label) {
                    return {
                        id: label.id.toString(),
                    };
                });
                params = {
                    app: appId,
                    id: recordId,
                    record: (_a = {},
                        _a[Kintone_1.CardApp.labelTable] = {
                            value: tableRecords,
                        },
                        _a),
                };
                return [4 /*yield*/, client.record.updateRecord(params)];
            case 1:
                _b.sent();
                return [2 /*return*/, params];
        }
    });
}); };
var addMemberToCard = function (client, appId, cardID, kintoneUserCode, kintoneUserCodesOfSetted) { return __awaiter(void 0, void 0, void 0, function () {
    var memberCodesWithJSON, params;
    var _a;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                memberCodesWithJSON = kintoneUserCodesOfSetted.map(function (code) {
                    return {
                        code: code.toString(),
                    };
                });
                memberCodesWithJSON.push({
                    code: kintoneUserCode,
                });
                params = {
                    app: appId,
                    id: cardID,
                    record: (_a = {},
                        _a[Kintone_1.CardApp.member] = {
                            value: memberCodesWithJSON,
                        },
                        _a),
                };
                return [4 /*yield*/, client.record.updateRecord(params)];
            case 1:
                _b.sent();
                return [2 /*return*/, params];
        }
    });
}); };
var removeMemberFromCard = function (client, appId, cardID, kintoneUserCode, kintoneUserCodesOfSetted) { return __awaiter(void 0, void 0, void 0, function () {
    var memberCodesWithJSON, params;
    var _a;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                memberCodesWithJSON = kintoneUserCodesOfSetted
                    .filter(function (code) { return code.toString() !== kintoneUserCode; })
                    .map(function (code) {
                    return {
                        code: code.toString(),
                    };
                });
                params = {
                    app: appId,
                    id: cardID,
                    record: (_a = {},
                        _a[Kintone_1.CardApp.member] = {
                            value: memberCodesWithJSON,
                        },
                        _a),
                };
                return [4 /*yield*/, client.record.updateRecord(params)];
            case 1:
                _b.sent();
                return [2 /*return*/, params];
        }
    });
}); };
var addTimeOfDoneToRecord = function (client, appId, recordId, doneTime) { return __awaiter(void 0, void 0, void 0, function () {
    var params;
    var _a;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                params = {
                    app: appId,
                    id: recordId,
                    record: (_a = {},
                        _a[Kintone_1.CardApp.doneTime] = {
                            value: doneTime,
                        },
                        _a),
                };
                return [4 /*yield*/, client.record.updateRecord(params)];
            case 1:
                _b.sent();
                return [2 /*return*/, params];
        }
    });
}); };
var commentCard = function (client, appId, entities, cardID) { return __awaiter(void 0, void 0, void 0, function () {
    var params;
    return __generator(this, function (_a) {
        switch (_a.label) {
            case 0:
                params = {
                    app: appId,
                    record: cardID,
                    comment: {
                        text: entities.memberCreator.username + ":" + entities.memberCreator.text + "\n\n" + entities.comment.text,
                    },
                };
                return [4 /*yield*/, client.record.addRecordComment(params)];
            case 1:
                _a.sent();
                return [2 /*return*/, params];
        }
    });
}); };
exports.registerRecordIdToTrello = function (id, baseUrl, cardAppId, trelloApiKey, trelloApiToken, eptreId, prefixRecordId) { return __awaiter(void 0, void 0, void 0, function () {
    var cardUrl, fetch, fetchUrl, fetchPromise;
    var _a;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                cardUrl = urlJoin(baseUrl, "/k/" + cardAppId + "/show#record=" + eptreId);
                fetch = require("node-fetch");
                fetchUrl = "https://api.trello.com/1/cards/" + id + "/attachments?key=" + trelloApiKey + "&token=" + trelloApiToken + "&name=" + prefixRecordId + "-" + eptreId + "&url=" + encodeURIComponent(cardUrl);
                console.log(fetchUrl);
                return [4 /*yield*/, fetch(fetchUrl, {
                        method: "POST",
                        headers: {
                            Accept: "application/json",
                        },
                    })];
            case 1:
                fetchPromise = _b.sent();
                _a = {
                    url: fetchPromise.url,
                    status: fetchPromise.status,
                    statusText: fetchPromise.statusText
                };
                return [4 /*yield*/, fetchPromise.text()];
            case 2: return [2 /*return*/, (_a.text = _b.sent(),
                    _a)];
        }
    });
}); };
exports.addRecordIdToCardNameOfTrello = function (cardId, trelloApiKey, trelloApiToken, nowCardName, eptreId, prefixRecordID) { return __awaiter(void 0, void 0, void 0, function () {
    var translateSpecialChar, translatedNowCardName, newName, eptreIdRegexp, newEPTREId, find, fetch, fetchUrl, fetchPromise;
    var _a;
    return __generator(this, function (_b) {
        switch (_b.label) {
            case 0:
                translateSpecialChar = function (s) {
                    // カード名に半角の & または # が含まれているとカード名が途切れてしまうので全角に変換する。
                    var replacedAmpersand = s.replace(/&/g, "＆");
                    var replacedSharp = replacedAmpersand.replace(/#/g, "＃");
                    return replacedSharp;
                };
                translatedNowCardName = translateSpecialChar(nowCardName);
                newName = translatedNowCardName;
                eptreIdRegexp = new RegExp("^" + prefixRecordID + "-\\d+:\\s");
                newEPTREId = prefixRecordID + "-" + eptreId + ": ";
                find = translatedNowCardName.match(eptreIdRegexp);
                if (find !== null) {
                    // すでに別のカードIDが存在していた場合は上書きする（copyCardを想定）
                    newName = newName.replace(eptreIdRegexp, newEPTREId);
                }
                else {
                    newName = "" + newEPTREId + translatedNowCardName;
                }
                if (translatedNowCardName === newName) {
                    // 新しいカード名が現在のカード名と同じ場合無視する
                    return [2 /*return*/, undefined];
                }
                fetch = require("node-fetch");
                fetchUrl = "https://api.trello.com/1/cards/" + cardId + "?key=" + trelloApiKey + "&token=" + trelloApiToken + "&name=" + encodeURI(newName);
                console.log(fetchUrl);
                return [4 /*yield*/, fetch(fetchUrl, {
                        method: "PUT",
                        headers: {
                            Accept: "application/json",
                        },
                    })];
            case 1:
                fetchPromise = _b.sent();
                _a = {
                    newName: newName,
                    url: fetchPromise.url,
                    status: fetchPromise.status,
                    statusText: fetchPromise.statusText
                };
                return [4 /*yield*/, fetchPromise.text()];
            case 2: return [2 /*return*/, (_a.text = _b.sent(),
                    _a)];
        }
    });
}); };
var attachmentToCard = function (client, appId, data, recordId, attachmentsTableIds) { return __awaiter(void 0, void 0, void 0, function () {
    var tableRecords, params;
    var _a, _b;
    return __generator(this, function (_c) {
        switch (_c.label) {
            case 0:
                tableRecords = attachmentsTableIds.map(function (records) {
                    return {
                        id: records.id.toString(),
                    };
                });
                tableRecords.push({
                    value: (_a = {},
                        _a[Kintone_1.CardApp.attachmentName] = data.attachment.name,
                        _a[Kintone_1.CardApp.attachmentLink] = data.attachment.url,
                        _a),
                });
                params = {
                    app: appId,
                    id: recordId,
                    record: (_b = {},
                        _b[Kintone_1.CardApp.attachmentTable] = {
                            value: tableRecords,
                        },
                        _b),
                };
                return [4 /*yield*/, client.record.updateRecord(params)];
            case 1:
                _c.sent();
                return [2 /*return*/, params];
        }
    });
}); };
exports.ApiExecutor = {
    createCard: createCard,
    updateCard: updateCard,
    createLabel: createLabel,
    updateLabel: updateLabel,
    createList: createList,
    updateList: updateList,
    addMember: addMember,
    addLabelToCard: addLabelToCard,
    removeLabelFromCard: removeLabelFromCard,
    addMemberToCard: addMemberToCard,
    getRecordIdFromCard: getRecordIdFromCard,
    getKintoneUserCode: getKintoneUserCode,
    getKintoneUserCodesOfSetted: getKintoneUserCodesOfSetted,
    getRecordIdAndLabelIdsFromCard: getRecordIdAndLabelIdsFromCard,
    getRecordIdFromLabelOfSame: getRecordIdFromLabelOfSame,
    removeMemberFromCard: removeMemberFromCard,
    getRecordIdFromList: getRecordIdFromList,
    addTimeOfDoneToRecord: addTimeOfDoneToRecord,
    commentCard: commentCard,
    registerRecordIdToTrello: exports.registerRecordIdToTrello,
    addRecordIdToCardNameOfTrello: exports.addRecordIdToCardNameOfTrello,
    attachmentToCard: attachmentToCard,
    getRecordIdAndAttachmentIdsFromCard: getRecordIdAndAttachmentIdsFromCard,
};
