"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SettingGuardian = void 0;
var SettingGuardian = /** @class */ (function () {
    function SettingGuardian(setting) {
        if (setting === void 0) { setting = {}; }
        this.setting = setting;
    }
    SettingGuardian.prototype.getPrefixRecordId = function () {
        var _a;
        return (_a = this.setting.prefixRecordId) !== null && _a !== void 0 ? _a : "DEFAULT";
    };
    SettingGuardian.prototype.isAddDoneTime = function (listName) {
        var _a;
        if (this.setting.isAddDoneTime === undefined || !this.setting.isAddDoneTime)
            return false;
        return listName === ((_a = this.setting.doneListName) !== null && _a !== void 0 ? _a : "Done");
    };
    SettingGuardian.prototype.isSkipEvent = function (trelloAction) {
        var _a;
        if (((_a = this.setting) === null || _a === void 0 ? void 0 : _a.excludes) === undefined) {
            return false;
        }
        var excludes = this.setting.excludes;
        var isCharacterOrLess = function (charactersOrLess) {
            return charactersOrLess >= trelloAction.data.card.name.length;
        };
        var isMatch = function (match) {
            return trelloAction.data.card.name.match(match) !== null;
        };
        var isSkip = false;
        for (var _i = 0, excludes_1 = excludes; _i < excludes_1.length; _i++) {
            var excludeSetting = excludes_1[_i];
            var checks = [];
            if (excludeSetting.charactersOrLess && trelloAction.data.card) {
                checks.push(isCharacterOrLess(excludeSetting.charactersOrLess));
            }
            if (excludeSetting.match && trelloAction.data.card) {
                checks.push(isMatch(excludeSetting.match));
            }
            if (checks.length === 0)
                continue;
            if (checks.every(function (isTrue) { return isTrue; })) {
                isSkip = true;
                break;
            }
        }
        return isSkip;
    };
    return SettingGuardian;
}());
exports.SettingGuardian = SettingGuardian;
