"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
/* eslint-disable no-loop-func */
var Trekin_1 = require("../Trekin");
var fs_1 = __importDefault(require("fs"));
var Worker_1 = require("../Worker");
jest.mock("../Worker");
var WorkerMock = Worker_1.Worker;
var createTrekin = function () {
    var t = new Trekin_1.Trekin({
        baseUrl: "",
        cards: { id: "", token: "" },
        defaultKintoneUserCode: "",
        labels: { id: "", token: "" },
        lists: { id: "", token: "" },
        members: { id: "", token: "" },
    }, { apiKey: "", apiToken: "" });
    WorkerMock.mockImplementation(function () {
        return {
            trelloAction: undefined,
            action: function () {
                return Promise.resolve("Not skip this event");
            },
        };
    });
    return t;
};
describe("readSettingのテスト", function () {
    var testcases = [
        {
            name: "ワーキングディレクトリにある.trekinrc.json5を読み込める",
            input: undefined,
            expected: {
                excludes: [
                    {
                        charactersOrLess: 12,
                    },
                ],
            },
        },
    ];
    var _loop_1 = function (name, input, expected) {
        test(name, function () { return __awaiter(void 0, void 0, void 0, function () {
            var t;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, createTrekin()];
                    case 1:
                        t = _a.sent();
                        return [4 /*yield*/, t.readSetting(input)];
                    case 2:
                        _a.sent();
                        expect(t.guardian.setting).toEqual(expected);
                        return [2 /*return*/];
                }
            });
        }); });
    };
    for (var _i = 0, testcases_1 = testcases; _i < testcases_1.length; _i++) {
        var _a = testcases_1[_i], name = _a.name, input = _a.input, expected = _a.expected;
        _loop_1(name, input, expected);
    }
});
describe("skipのテスト", function () {
    var testcases = [
        {
            name: "12文字以内はskipできる",
            input: [
                "./src/__tests__/trekin_settings/charactersOrLess_only.trekinrc.json5",
                "./src/__tests__/trello_events/skipCreateCard_1.json",
            ],
            expected: "Skip this event",
        },
        {
            name: "「↑2020/08/20」はskipできる",
            input: [
                "./src/__tests__/trekin_settings/match_only_1.trekinrc.json5",
                "./src/__tests__/trello_events/skipCreateCard_1.json",
            ],
            expected: "Skip this event",
        },
        {
            name: "「\\d{4}\\/\\d{2}\\/\\d{2}」はskipできる",
            input: [
                "./src/__tests__/trekin_settings/match_only_2.trekinrc.json5",
                "./src/__tests__/trello_events/skipCreateCard_1.json",
            ],
            expected: "Skip this event",
        },
        {
            name: "「12文字以内」かつ「\\d{4}\\/\\d{2}\\/\\d{2}」はskipできる",
            input: [
                "./src/__tests__/trekin_settings/multiple_rule_1.trekinrc.json5",
                "./src/__tests__/trello_events/skipCreateCard_1.json",
            ],
            expected: "Skip this event",
        },
        {
            name: "「\\d{4}\\/\\d{2}\\/\\d{2}」にはマッチするが「12文字以内」にマッチしないのでskipしない",
            input: [
                "./src/__tests__/trekin_settings/multiple_rule_1.trekinrc.json5",
                "./src/__tests__/trello_events/skipCreateCard_2.json",
            ],
            expected: "Not skip this event",
        },
        {
            name: "「12文字以内」にはマッチするが「\\d{4}\\/\\d{2}\\/\\d{2}」にマッチしないのでskipしない",
            input: [
                "./src/__tests__/trekin_settings/multiple_rule_1.trekinrc.json5",
                "./src/__tests__/trello_events/skipCreateCard_3.json",
            ],
            expected: "Not skip this event",
        },
        {
            name: "1つめのルールにはマッチしないが2つめのルールにマッチするのでskipする",
            input: [
                "./src/__tests__/trekin_settings/multiple_rule_2.trekinrc.json5",
                "./src/__tests__/trello_events/skipCreateCard_1.json",
            ],
            expected: "Skip this event",
        },
        {
            name: "どのルールにもにマッチしないのでskipする",
            input: [
                "./src/__tests__/trekin_settings/multiple_rule_2.trekinrc.json5",
                "./src/__tests__/trello_events/createCard_1.json",
            ],
            expected: "Not skip this event",
        },
    ];
    var _loop_2 = function (name, input, expected) {
        test(name, function () { return __awaiter(void 0, void 0, void 0, function () {
            var t, action, _a, _b, actual;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0: return [4 /*yield*/, createTrekin()];
                    case 1:
                        t = _c.sent();
                        return [4 /*yield*/, t.readSetting(input[0])];
                    case 2:
                        _c.sent();
                        _b = (_a = JSON).parse;
                        return [4 /*yield*/, fs_1.default.readFileSync(input[1], "utf8")];
                    case 3:
                        action = _b.apply(_a, [_c.sent()])
                            .body.action;
                        return [4 /*yield*/, t.operation(action)];
                    case 4:
                        actual = _c.sent();
                        expect(actual).toEqual(expected);
                        return [2 /*return*/];
                }
            });
        }); });
    };
    for (var _i = 0, testcases_2 = testcases; _i < testcases_2.length; _i++) {
        var _a = testcases_2[_i], name = _a.name, input = _a.input, expected = _a.expected;
        _loop_2(name, input, expected);
    }
});
describe("addDoneTimeのテスト", function () {
    var testcases = [
        {
            name: "カスタムdone名とアフターリスト名が一致するのでAddDoneTime()でtrueを返す",
            input: [
                "./src/__tests__/trekin_settings/enableAddDoneTime_1.trekinrc.json5",
                "./src/__tests__/trello_events/updateCard_idList_3.json",
            ],
            expected: true,
        },
        {
            name: "カスタムdone名とアフターリスト名が一致しないのでAddDoneTime()でfalseを返す",
            input: [
                "./src/__tests__/trekin_settings/enableAddDoneTime_1.trekinrc.json5",
                "./src/__tests__/trello_events/updateCard_idList_2.json",
            ],
            expected: false,
        },
        {
            name: "デフォルトdone名とアフターリスト名が一致するのでAddDoneTime()でtrueを返す",
            input: [
                "./src/__tests__/trekin_settings/enableAddDoneTime_2.trekinrc.json5",
                "./src/__tests__/trello_events/updateCard_idList_4.json",
            ],
            expected: true,
        },
        {
            name: "デフォルトdone名とアフターリスト名が一致しないのでAddDoneTime()でfalseを返す",
            input: [
                "./src/__tests__/trekin_settings/enableAddDoneTime_2.trekinrc.json5",
                "./src/__tests__/trello_events/updateCard_idList_2.json",
            ],
            expected: false,
        },
        {
            name: "isAddDoneTimeがfalseなのでAddDoneTime()でfalseを返す",
            input: [
                "./src/__tests__/trekin_settings/.trekinrc.json5",
                "./src/__tests__/trello_events/updateCard_idList_4.json",
            ],
            expected: false,
        },
    ];
    var _loop_3 = function (name, input, expected) {
        test(name, function () { return __awaiter(void 0, void 0, void 0, function () {
            var t, action, _a, _b, actual;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0: return [4 /*yield*/, createTrekin()];
                    case 1:
                        t = _c.sent();
                        return [4 /*yield*/, t.readSetting(input[0])];
                    case 2:
                        _c.sent();
                        _b = (_a = JSON).parse;
                        return [4 /*yield*/, fs_1.default.readFileSync(input[1], "utf8")];
                    case 3:
                        action = _b.apply(_a, [_c.sent()])
                            .body.action;
                        actual = t.guardian.isAddDoneTime(action.data.listAfter.name);
                        expect(actual).toEqual(expected);
                        return [2 /*return*/];
                }
            });
        }); });
    };
    for (var _i = 0, testcases_3 = testcases; _i < testcases_3.length; _i++) {
        var _a = testcases_3[_i], name = _a.name, input = _a.input, expected = _a.expected;
        _loop_3(name, input, expected);
    }
});
describe("getPrefixRecordIdのテスト", function () {
    var testcases = [
        {
            name: "設定しているprefixRecordIdを返す",
            input: ["./src/__tests__/trekin_settings/prefixRecordId.trekinrc.json5"],
            expected: "TEST",
        },
        {
            name: "未設定の場合はDEFAULTを返す",
            input: [
                "./src/__tests__/trekin_settings/enableAddDoneTime_1.trekinrc.json5",
            ],
            expected: "DEFAULT",
        },
    ];
    var _loop_4 = function (name, input, expected) {
        test(name, function () { return __awaiter(void 0, void 0, void 0, function () {
            var t, actual;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, createTrekin()];
                    case 1:
                        t = _a.sent();
                        return [4 /*yield*/, t.readSetting(input[0])];
                    case 2:
                        _a.sent();
                        actual = t.guardian.getPrefixRecordId();
                        expect(actual).toEqual(expected);
                        return [2 /*return*/];
                }
            });
        }); });
    };
    for (var _i = 0, testcases_4 = testcases; _i < testcases_4.length; _i++) {
        var _a = testcases_4[_i], name = _a.name, input = _a.input, expected = _a.expected;
        _loop_4(name, input, expected);
    }
});
