"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var fs_1 = __importDefault(require("fs"));
var Worker_1 = require("../Worker");
var rest_api_client_1 = require("@kintone/rest-api-client");
var Setting_1 = require("../Setting");
var ApiExecutor_1 = require("../ApiExecutor");
var JSON5 = require("json5");
jest.mock("@kintone/rest-api-client");
var KintoneMock = rest_api_client_1.KintoneRestAPIClient;
jest.mock("../ApiExecutor");
var getRecordIdFromCardMock = ApiExecutor_1.ApiExecutor.getRecordIdFromCard;
var addTimeOfDoneToRecordMock = ApiExecutor_1.ApiExecutor.addTimeOfDoneToRecord;
var createWorker = function () {
    var w = new Worker_1.Worker({
        baseUrl: "",
        cards: { id: "", token: "" },
        defaultKintoneUserCode: "",
        labels: { id: "", token: "" },
        lists: { id: "", token: "" },
        members: { id: "", token: "" },
    }, { apiKey: "", apiToken: "" });
    return w;
};
describe("addTimeOfDoneToRecordのテスト", function () {
    var testcases = [
        {
            name: "変更日時を取得できる",
            input: {
                actionPath: "./src/__tests__/trello_events/updateCard_idList_3.json",
                settingPath: "./src/__tests__/trekin_settings/enableAddDoneTime_1.trekinrc.json5",
            },
            expected: "2020-07-31T02:53:23.814Z",
        },
        {
            name: "doneじゃないのでスキップする",
            input: {
                actionPath: "./src/__tests__/trello_events/updateCard_idList_1.json",
                settingPath: "./src/__tests__/trekin_settings/enableAddDoneTime_1.trekinrc.json5",
            },
            expected: "Skip addTimeOfDoneToRecord",
        },
        {
            name: "リスト移動じゃないのでスキップする",
            input: {
                actionPath: "./src/__tests__/trello_events/createCard_1.json",
                settingPath: "./src/__tests__/trekin_settings/enableAddDoneTime_1.trekinrc.json5",
            },
            expected: "Skip addTimeOfDoneToRecord",
        },
    ];
    var _loop_1 = function (name, input, expected) {
        test(name, function () { return __awaiter(void 0, void 0, void 0, function () {
            var w, action, _a, _b, actual;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        KintoneMock.mockImplementation(function () {
                            return true;
                        });
                        getRecordIdFromCardMock.mockImplementation(function () {
                            return "1";
                        });
                        addTimeOfDoneToRecordMock.mockImplementation(function (_client, _cardId, _recordId, doneTime) {
                            return doneTime;
                        });
                        return [4 /*yield*/, createWorker()];
                    case 1:
                        w = _c.sent();
                        w.setting = new Setting_1.SettingGuardian(JSON5.parse(fs_1.default.readFileSync(input.settingPath, "utf-8")));
                        _b = (_a = JSON).parse;
                        return [4 /*yield*/, fs_1.default.readFileSync(input.actionPath, "utf8")];
                    case 2:
                        action = _b.apply(_a, [_c.sent()]).body.action;
                        w.trelloAction = action;
                        return [4 /*yield*/, w.addTimeOfDoneToRecord()];
                    case 3:
                        actual = _c.sent();
                        expect(actual).toEqual(expected);
                        return [2 /*return*/];
                }
            });
        }); });
    };
    for (var _i = 0, testcases_1 = testcases; _i < testcases_1.length; _i++) {
        var _a = testcases_1[_i], name = _a.name, input = _a.input, expected = _a.expected;
        _loop_1(name, input, expected);
    }
});
